function CF_FindFactionStoragePath(modulename)
	local paths = {};
	paths[1] = "./Factions/";
	paths[2] = "./"..modulename.."/Factions/";
	paths[3] = "/Applications/Cortex Command b26.app/Contents/Resources/Factions/";
	paths[4] = "/Applications/Cortex Command b26.app/Contents/Resources/"..modulename.."/Factions/";

	for i = 1, #paths do
		if CF_IsFileExists(paths[i].."Factions.cfg") then
			print ("PATH="..paths[i])
			return paths[i]
		end
	end
	
	return nil;
end
-----------------------------------------------------------------------------
-- Read data from file line by line and return the list
-----------------------------------------------------------------------------
function CF_ReadFactionsList(path , filename)
	print("CF_ReadFactionsList")
	io = require("io");
	local config = {};
	
	for line in io.lines(path..filename) do
		s = string.gsub(line , "\n" , "");
		if string.find(s , "*") == nil then
			config[#config + 1] = s;
		end
	end
	
	return config;
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function CF_ParseLine(s)
	local pos1 , pos2;
	
	pos = string.find(s ,"=");
	
	if pos ~= nil then
		local  param , value;

		s = string.gsub(s , "\n" , "");
		param = string.sub(s , 1 , pos - 1);
		value = string.sub(s , pos + 1 , string.len(s));

		return param , value;
	else
		return nil;
	end
end
-----------------------------------------------------------------------------
--
-----------------------------------------------------------------------------
function CF_ReadConfigFile(modulename , filename)
	io = require("io");
	local config = {};
	local fullpath = CF_FindFactionStoragePath(modulename)..filename
	
	for line in io.lines(fullpath) do
		local param , value;
		
		param, value = CF_ParseLine(line);
		config[param] = value;
	end
	
	return config;
end
-----------------------------------------------------------------------------
--
-----------------------------------------------------------------------------
function CF_WriteConfigFile(config , modulename , filename)
	io = require("io");
	local fullpath = CF_FindFactionStoragePath(modulename)..filename
	
	local file = io.open(fullpath , "w");
	
	for i,line in pairs(config) do
		file:write(tostring(i).."="..tostring(line).."\n");
	end
	
	file:close();
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function CF_IsFileExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------
--
-----------------------------------------------------------------------------
