-----------------------------------------------------------------------------------------
-- Generic functions to add to library
-----------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-- Initialize global faction lists
-----------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
-- Initialize global faction lists
-----------------------------------------------------------------------------------------
function CF_InitFactions(modulename)
	print ("CF_InitFactions");
	CF_Activity = ActivityMan:GetActivity();
	CF_PlayerTeam = Activity.TEAM_1;
   	CF_CPUTeam = Activity.TEAM_2;
	CF_RogueTeam = Activity.TEAM_3;
	CF_MOIDLimit = 220;

	CF_PlayerFaction = "Dummy";
	CF_CPUFaction = "Dummy";
	
	CF_Factions = {};
	CF_InfantryModules = {};
	CF_FactionIds = {};
	CF_FactionNames = {};
	CF_FactionPlayable = {};
	CF_FactionIcon = {};
	CF_FactionIconModules = {};
	
	CF_FactionModules = {};
	CF_LightWeaponSets = {};
	CF_LightWeaponSetModules = {};

	CF_HeavyWeaponSets = {};
	CF_HeavyWeaponSetModules = {};

	CF_ExplosiveSets = {};
	CF_ExplosiveSetModules = {};

	CF_ActorSets = {};
	CF_ActorSetModules = {};	

	CF_AltActorSets = {};
	CF_AltInfantryModules = {};
	
	CF_BrainPresets = {};
	CF_BrainPresetModules = {};

	CF_Probabilities = {};

	CF_AllowedActors = {};

	CF_RocketLaunchers = {};
	CF_RocketLauncherModules = {};

	CF_SniperRifles = {};
	CF_SniperRifleModules = {};
	
	CF_Dropships = {};
	CF_DropshipModules = {};

	CF_ArmorCrabs = {}
	CF_ArmorCrabModules = {}

	CF_ArmorHumans = {}
	CF_ArmorHumanModules = {}
	
	CF_ArmorPistols = {}
	CF_ArmorPistolModules = {}
	
	CF_ArmorShields = {}
	CF_ArmorShieldModules = {}

	CF_EliteWeaponSets = {}
	CF_EliteWeaponSetModules = {}

	CF_Turrets = {};
	CF_TurretModules = {};
	CF_TurretOffsetsReplace = {};
	CF_TurretOffsetsGarrison = {};

	CF_LastStandMission = {}
	CF_LastStandMissionScene = {}
	
	CF_ConfigPath = CF_FindFactionStoragePath(modulename)
	CF_FactionFiles = CF_ReadFactionsList(CF_ConfigPath , "Factions.cfg")

	-- Load factions data
	for i = 1, #CF_FactionFiles do
		print("Loading "..CF_FactionFiles[i])
		f = loadfile(CF_ConfigPath..CF_FactionFiles[i])
		f()
	end
	
	print("Factions loaded:")
	for i = 1 , #CF_Factions do
		print(CF_Factions[i])
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_MakeWeapon(faction , islight)
	--print ("CF_MakeWeapon");

	if faction == "$$$random$$$" then
		return CF_MakeWeapon(CF_Factions[math.random(#CF_Factions)] , islight)
	end
	
	local weapon;
	local r;
	
	weapon = nil;
	
	if islight then
		if CF_LightWeaponSets[faction] ~= nil then
			r = math.random(#CF_LightWeaponSets[faction]);
			weapon = CreateHDFirearm(CF_LightWeaponSets[faction][r] , CF_InfantryModules[faction]);
		end
	else
		if CF_HeavyWeaponSets[faction] ~= nil then
			r = math.random(#CF_HeavyWeaponSets[faction]);
			weapon = CreateHDFirearm(CF_HeavyWeaponSets[faction][r] , CF_InfantryModules[faction]);
		end
	end
	
	return weapon;
end
-----------------------------------------------------------------------------------------
-- Make explosive. faction - actor faction number
-----------------------------------------------------------------------------------------
function CF_MakeExplosive(faction)
	--print ("CF_MakeExplosive");

	if faction == "$$$random$$$" then
		return CF_MakeExplosive(CF_Factions[math.random(#CF_Factions)])
	end
	
	local weapon;
	local r;
	
	weapon = nil;
	if CF_ExplosiveSets[faction] ~= nil then
		r = math.random(#CF_ExplosiveSets[faction]);
		weapon = CreateTDExplosive(CF_ExplosiveSets[faction][r] , CF_InfantryModules[faction]);
	end
	
	return weapon
end
-----------------------------------------------------------------------------------------
-- Spawns armor of selected faction. Returns actor, price.
-----------------------------------------------------------------------------------------
function CF_SpawnArmor(team , pos , faction , aimode)
	--print ("CF_SpawnArmor");
	
	if faction == "$$$random$$$" then
		return CF_SpawnArmor(team , pos, CF_Factions[math.random(#CF_Factions)] , aimode)
	end
	
	local actor = nil;
	local r;
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		if CF_ArmorCrabs[faction] ~= nil then
			r = math.random(#CF_ArmorCrabs[faction]);
			actor = CreateACrab(CF_ArmorCrabs[faction][r], CF_InfantryModules[faction]);
		elseif CF_ArmorHumans[faction] ~= nil then
			print ("Spawn armor actor")
			r = math.random(#CF_ArmorHumans[faction]);
			actor = CreateAHuman(CF_ArmorHumans[faction][r], CF_InfantryModules[faction]);
		else
			actor = CF_SpawnRandomInfantry(team , nil , faction , aimode);
		end
		
		actor.AIMode = aimode;
		actor.Team = team;
		
		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor;
		end
	end
	
	return nil;
end
-----------------------------------------------------------------------------------------
-- Creates but does not put dropship unit
-----------------------------------------------------------------------------------------
function CF_MakeDropship(team , pos , faction, ignoremoids)
	-- We need to ignore moids when we're spawning brain drop ship
	if not ignoremoids then
		if MovableMan:GetMOIDCount() > CF_MOIDLimit then
			return nil
		end
	end

	local r;
	local preset = "Drop Ship MK1";
	local module = "Base.rte";
	
	if CF_Dropships and CF_Dropships[faction] then
		r = math.random(#CF_Dropships[faction])
		preset = CF_Dropships[faction][r]
		module = CF_DropshipModules[faction][r]
	end
	
	local ship = CreateACDropShip(preset, module)
	
	ship.Team = team
	if pos then
		ship.Pos = pos
	end
	ship.AIMode = Actor.AIMODE_DELIVER
	ship:SetControllerMode(Controller.CIM_AI, -1);
	
	return ship
end
-----------------------------------------------------------------------------------------
-- Creates but does not put brain unit
-----------------------------------------------------------------------------------------
function CF_MakeBrain(team , faction, ignoremoids)
	-- We need to ignore moids when we're spawning brain drop ship
	if not ignoremoids then
		if MovableMan:GetMOIDCount() > CF_MOIDLimit then
			return nil
		end
	end

	local r;
	local preset = "Brain Robot";
	local module = "Base.rte";
	
	if CF_BrainPresets and CF_BrainPresets[faction] then
		r = math.random(#CF_BrainPresets[faction])
		preset = CF_BrainPresets[faction][r]
		module = CF_BrainPresetModules[faction][r]
	end
	
	local actor = CreateAHuman(preset, module)
	actor:AddInventoryItem(CF_MakeWeapon(faction , false))
	actor:AddInventoryItem(CF_MakeWeapon(faction , true))
	actor.Team = team
	actor.AIMode = Actor.AIMODE_SENTRY
	
	return actor
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_SpawnRandomInfantry(team , pos , faction , aimode)
	--print ("CF_SpawnRandomInfantry");

	if faction == "$$$random$$$" then
		return CF_SpawnRandomInfantry(team , pos , CF_Factions[math.random(#CF_Factions)] , aimode)
	end

	local actor = nil;
	local r;
	local item;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		if CF_AltActorSets and CF_AltActorSets[faction] then
			r = math.random(#CF_AltActorSets[faction]);
			actor = CreateAHuman(CF_AltActorSets[faction][r] , CF_AltInfantryModules[faction][r]);
		else
			r = math.random(#CF_ActorSets[faction]);
			actor = CreateAHuman(CF_ActorSets[faction][r] , CF_InfantryModules[faction]);
		end
	
		-- probability to give a secondary weapon
		-- which is always light
		if math.random() < CF_Probabilities[faction][2] then
			item = CF_MakeWeapon(faction , true);
			if item ~= nil then
				actor:AddInventoryItem(item);
			end
		end
		
		-- probability to give a heavy weapon
		if math.random() < CF_Probabilities[faction][1] then
			item = CF_MakeWeapon(faction , false);
			if item ~= nil then
				actor:AddInventoryItem(item);
			end
		else
			item = CF_MakeWeapon(faction , true);
			if item ~= nil then
				actor:AddInventoryItem(item);
			end
		end
		
		-- probability to give an explosive
		if math.random() < CF_Probabilities[faction][3] then
			item = CF_MakeExplosive(faction);
			if item ~= nil then
				actor:AddInventoryItem(item);
			end
		end

		-- probability to give a second explosive
		if math.random() < CF_Probabilities[faction][4] then
			item = CF_MakeExplosive(faction);
			if item ~= nil then
				actor:AddInventoryItem(item);
			end
		end
		
		actor.AIMode = aimode;
		actor.Team = team;
		
		if pos ~= nil then
			actor.Pos = pos;
			MovableMan:AddActor(actor);
		else
			return actor;
		end
	end
	
	return nil;
end
-----------------------------------------------------------------------------------------
-- Replace default dummy actors placed manually to faction-specific actors
-----------------------------------------------------------------------------------------
function CF_ReplaceActors(config , collection)
	print ("CF_ReplaceActors");
	local team;
	local toremove;
	local lpos;
	local viewpoint;
	local colls = {};
    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in collection do
		toremove = false; 
		
		if actor.Team ~= CF_RogueTeam then
			--print(actor.PresetName);
			-- Replace soldier units
			if actor.PresetName == "Dummy" then
				lpos = Vector(actor.Pos.X , actor.Pos.Y);
				actor.Pos = Vector(0 , 30000);
				toremove = true;
				if actor.Team == CF_PlayerTeam then
					CF_SpawnRandomInfantry(CF_PlayerTeam , lpos , CF_PlayerFaction , Actor.AIMODE_SENTRY);
				else
					CF_SpawnRandomInfantry(CF_CPUTeam , lpos , CF_CPUFaction , Actor.AIMODE_SENTRY);
				end
			end

			-- Replace armor units
			if actor.PresetName == "Dreadnought" then
				lpos = Vector(actor.Pos.X , actor.Pos.Y);
				actor.Pos = Vector(0 , 30000);
				toremove = true;
				if actor.Team == CF_PlayerTeam then
					CF_SpawnArmor(CF_PlayerTeam , lpos , CF_PlayerFaction , Actor.AIMODE_SENTRY);
				else
					CF_SpawnArmor(CF_CPUTeam , lpos , CF_CPUFaction , Actor.AIMODE_SENTRY);
				end
			end
		end
		
		if toremove then 
			actor.Lifetime = 0
			ActivityMan:GetActivity():ReportDeath(actor.Team , -1)
		end
    end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_GetCPUFaction(config)
	print ("CF_GetCPUFaction");
	faction = config["CPUFaction"];
	
	return faction;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_GetPlayerFaction(config)
	print ("CF_GetPlayerFaction");
	faction = config["PlayerFaction"];
	
	return faction;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function CF_InitMission(config)
	CF_PlayerFaction = CF_GetPlayerFaction(config);
	CF_CPUFaction = CF_GetCPUFaction(config);
end
-------------------------------------------------------------------------------
-- Parses given presetname into Preset : Experience tuple
-------------------------------------------------------------------------------
function CF_ParsePresetName(s)
	local pos1 , pos2;
	
	pos = string.find(s ,":");
	
	if pos ~= nil then
		local  preset , exppoints;

		--s = string.gsub(s , "\n" , "");
		preset = string.sub(s , 1 , pos - 1);
		exppoints = string.sub(s , pos + 1 , string.len(s));

		return preset , tonumber(exppoints);
	else
		return s , nil;
	end
end
