-----------------------------------------------------------------------------------------
--	Load event. Put all UI element initialiations here.
-----------------------------------------------------------------------------------------
function Warfare2:FormLoad()
	self.FormValid = true;

	ACTIVITY_IN_UI_MODE = true;
	
	local el;
	
	-- Clear old elements
	self.UI = {}

	el = {}
	el["Type"] = self.ElementTypes.LABEL;
	el["Preset"] = nil
	el["Pos"] = self.Mid + Vector(0,-184)
	el["Text"] = "SELECT PLAYER FACTION"
	el["Width"] = 800;
	el["Height"] = 100;

	self.UI[#self.UI + 1] = el;
	self.LblPhase = el

	el = {}
	el["Type"] = self.ElementTypes.LABEL;
	el["Preset"] = nil
	el["Pos"] = self.Mid + Vector(-190,-144)
	el["Text"] = " - "
	el["Width"] = 400;
	el["Height"] = 100;
	el["Centered"] = false;

	self.UI[#self.UI + 1] = el;
	self.LblFactionDescription = el

	el = {}
	el["Type"] = self.ElementTypes.LABEL;
	el["Preset"] = nil
	el["Pos"] = self.Mid + Vector(0,-164)
	el["Text"] = ""
	el["Width"] = 400;
	el["Height"] = 100;

	self.UI[#self.UI + 1] = el;
	self.LblFactionName = el
	
	-- Load factions
	self.PlayableFactionCount = 1;
	
	self.FactionButtons = {}
	
	for i = 1, #CF_Factions do
		if CF_FactionPlayable[CF_Factions[i]] then
			self.FactionButtons[self.PlayableFactionCount] = {};
			
			self.FactionButtons[self.PlayableFactionCount]["Description"] = CF_FactionDescriptions[CF_Factions[i]];
			self.FactionButtons[self.PlayableFactionCount]["FactionName"] = CF_FactionNames[CF_Factions[i]];
			self.FactionButtons[self.PlayableFactionCount]["FactionId"] = CF_Factions[i];
			self.FactionButtons[self.PlayableFactionCount]["Width"] = 60
			self.FactionButtons[self.PlayableFactionCount]["Height"] = 70
			self.PlayableFactionCount = self.PlayableFactionCount + 1;
		end
	end
	
	self.PlayableFactionCount = self.PlayableFactionCount - 1;

	self.FactionButtonsPerRow = 10; -- Plates per row
	
	if self.PlayableFactionCount < self.FactionButtonsPerRow then
		self.FactionButtonsPerRow = self.PlayableFactionCount
	end
	
	self.Rows = math.floor(self.PlayableFactionCount / self.FactionButtonsPerRow + 1)

	local xtile = 1
	local ytile = 1
	local tilesperrow = 0
	
	-- Init factions UI
	for i = 1 , self.PlayableFactionCount do
		if i <= self.PlayableFactionCount - self.PlayableFactionCount % self.FactionButtonsPerRow then
			tilesperrow = self.FactionButtonsPerRow
		else
			tilesperrow = self.PlayableFactionCount % self.FactionButtonsPerRow
		end
		
		self.FactionButtons[i]["Pos"] = Vector((self.MidX) - ((tilesperrow * 58) / 2) + (xtile * 58) - (58 / 2), 
											   (self.MidY) - ((self.Rows * 68) / 2) + (ytile * 68) - (68 / 2))
		
		xtile = xtile + 1
		if xtile > self.FactionButtonsPerRow then
			xtile = 1
			ytile = ytile + 1
		end
	end

	self:RedrawFactionButtons();

	for i = 1 , self.PlayableFactionCount do
		CF_SpawnRandomInfantry(-1 , self.FactionButtons[i]["Pos"] , self.FactionButtons[i]["FactionId"] , Actor.AIMODE_SENTRY)
	end
	
	-- Interface logic
	self.Phases = {PLAYER = 0, CPU = 1}
	self.Phase = self.Phases.PLAYER;
	
	-- Selections
	self.SelectedPlayerFaction = 0
	self.SelectedCPUFaction = 0
	
	-- Draw selection plates
	self.SelectionButtons = {}
	local xtile = 1

	for i = 1, 2 do
		self.SelectionButtons[i] = {};
		self.SelectionButtons[i]["Pos"] = Vector((self.MidX) - (((2) * 58) / 2) + (xtile * 58) - (58 / 2), self.MidY + 90)
		self:RedrawFactionButton(self.SelectionButtons[i], self.ButtonStates.IDLE)
		xtile = xtile + 1
		
		-- Add labels
		el = {}
		el["Type"] = self.ElementTypes.LABEL;
		el["Preset"] = nil
		el["Pos"] = self.SelectionButtons[i]["Pos"] + Vector(0,-40)
		if i == 1 then
			el["Text"] = "PLAYER"
		else
			el["Text"] = "CPU "
		end
		el["Width"] = 800;
		el["Height"] = 100;

		self.UI[#self.UI + 1] = el;
	end
end
-----------------------------------------------------------------------------------------
-- Redraw new campaign dialog mission plate
-----------------------------------------------------------------------------------------
function Warfare2:RedrawFactionButton(el , state)
	if el["State"] ~= state then
		el["State"] = state
	
		if MovableMan:IsParticle(el["Particle"]) then
			el["Particle"].ToDelete = true
			el["Particle"] = nil;
		end

		local preset = "FactionBannerIdle";
		
		if state == self.ButtonStates.MOUSE_OVER then
			preset = "FactionBannerMouseOver"
		elseif state == self.ButtonStates.PRESSED then
			preset = "FactionBannerPressed"
		end

		el["Particle"] = CreateMOSRotating(preset , self.ModuleName);

		el["Particle"].Pos = el["Pos"];
		MovableMan:AddParticle(el["Particle"]);	
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Warfare2:RedrawFactionButtons()
	for i = 1, #self.FactionButtons do
		self:RedrawFactionButton(self.FactionButtons[i] , self.ButtonStates.IDLE);
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:BtnOk_OnClick()
	PLAYER_FACTION = self.FactionButtons[self.SelectedPlayerFaction]["FactionId"]
	CPU_FACTION = self.FactionButtons[self.SelectedCPUFaction]["FactionId"]
	ACTIVITY_IN_UI_MODE = false;
	
	--for plr = 0 , self.PlayerCount - 1 do
	--	self:SetPlayerBrain(nil, plr);
	--end
	
	self:FormClose();
	
	self.IsInitialized = false;
	print ("-----------------------------------")
	print (SCENE_TO_LAUNCH)
	MovableMan:PurgeAllMOs();
	SceneMan:LoadScene(SCENE_TO_LAUNCH, true);	
	dofile(BASE_PATH.."WarfareGameplay.lua")
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:GetFactionButtonUnderMouse(pos)
	for i = 1, #self.FactionButtons do
		local elpos = self.FactionButtons[i]["Pos"]
		local wx = self.FactionButtons[i]["Width"]
		local wy = self.FactionButtons[i]["Height"]
		
		if pos.X > elpos.X - (wx / 2) and pos.X < elpos.X + (wx / 2) and pos.Y > elpos.Y - (wy / 2) and pos.Y < elpos.Y + (wy / 2) then
			return i;
		end	
	end
	
	return nil;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:FormClick()
	local f = self:GetFactionButtonUnderMouse(self.Mouse)

	if f ~= nil then
		if self.Phase ==  self.Phases.PLAYER then
			self.SelectedPlayerFaction = f;
			self.LblPhase["Text"] = "SELECT CPU FACTION"
			
			CF_SpawnRandomInfantry(-1 , self.SelectionButtons[1]["Pos"] , self.FactionButtons[f]["FactionId"] , Actor.AIMODE_SENTRY)
		elseif self.Phase == self.Phases.CPU then
			self.SelectedCPUFaction = f
			self:BtnOk_OnClick()
		end
		
		if self.Phase <= self.Phases.CPU then
			self.Phase = self.Phase + 1
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:FormUpdate()
	-- Redraw plates on hover or press
	local f = self:GetFactionButtonUnderMouse(self.Mouse)

	if self.LastMouseOver and self.LastMouseOver ~= f then
		self:RedrawFactionButton(self.FactionButtons[self.LastMouseOver], self.ButtonStates.IDLE);

		-- Update faction description
		self.LblFactionDescription["Text"] = "";
		self.LblFactionName["Text"] = "";
	end
	
	if f ~= nil then
		if self.MouseButtonHeld then
			self:RedrawFactionButton(self.FactionButtons[f], self.ButtonStates.PRESS);
		else
			self:RedrawFactionButton(self.FactionButtons[f], self.ButtonStates.MOUSE_OVER);
			
			-- Update faction description
			self.LblFactionDescription["Text"] = self.FactionButtons[f]["Description"]
			self.LblFactionName["Text"] = string.upper(self.FactionButtons[f]["FactionName"]);
		end
		self.LastMouseOver = f;
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:FormDraw()

end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:FormClose()
	self.FormValid = false;

	print ("FormNewGame:Close")

	-- Destroy actors
	for actor in MovableMan.Actors do
		if actor.PresetName ~= "Brain Case" then
			actor.ToDelete = true;
		end
	end
	
	-- Destroy plates
	for i = 1, #self.FactionButtons do
		if MovableMan:IsParticle(self.FactionButtons[i]["Particle"]) then
			self.FactionButtons[i]["Particle"].ToDelete = true
			self.FactionButtons[i]["Particle"] = nil;
		end	
	end
	
	for i = 1, #self.SelectionButtons do
		if MovableMan:IsParticle(self.SelectionButtons[i]["Particle"]) then
			self.SelectionButtons[i]["Particle"].ToDelete = true
			self.SelectionButtons[i]["Particle"] = nil;
		end	
	end
	
	self.FactionButtons = {}
	self.SelectionButtons = {}
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
