-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Warfare2:StartActivity()
	print ("Warfare2:StrategyScreen:StartActivity");

	CF_EnableKeyboardControls = false;
	
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end

	if self.IsInitialized then 
		return
	end

	self.GS = {};
	
	CF_InitFactions(self)
	
	self.ModuleName = "Warfare2.rte";
	
	self.MidX = SceneMan.Scene.Width / 2;
	self.MidY = SceneMan.Scene.Height / 2;
	self.Mid = Vector(self.MidX , self.MidY);
	
	self.ResX = FrameMan.ResX
	self.ResY = FrameMan.ResY

	self.ResX2 = FrameMan.ResX / 2
	self.ResY2 = FrameMan.ResY / 2
	
	self.Mouse = self.Mid;
	
	self.ExitImmediately = false;
	
	--Make an invisible brain.
	for p = 0, self.PlayerCount - 1 do
		self.brain = CreateActor("Fake Brain");
		self.brain.Team = 0;
		self.brain.Pos = self.Mid + Vector(0, p * 25);
		MovableMan:AddActor(self.brain);
		self:SetPlayerBrain(self.brain, p);
		self:SwitchToActor(self.brain, p,-1);
	end
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	-- How many times to redraw cursor glows to make it less transparent
	self.CURSOR_REDRAW_COUNT = 1

	-- How many times to redraw button glows to make it less transparent
	self.BUTTON_REDRAW_COUNT = 1
	
	self.ElementTypes = {BUTTON = 0, LABEL = 1, PLANET = 2}
	self.ButtonStates = {IDLE = 0, MOUSE_OVER = 1, PRESSED = 2}
	
	self.UI = {}
	
	-- Init form
	self:FormLoad();
	
	self.MouseOverElement = nil;
	self.MousePressedElement = nil;
	self.MousePressStartElement = nil;
	self.MousePressEndElement = nil;
	
	self.IsInitialized = true	
	
	self:SetTeamFunds(0 , 0);	
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function Warfare2:PauseActivity(pause)
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function Warfare2:EndActivity()
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Warfare2:ClearMessages()
	self.Messages = {}
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:DrawMouseCursor()
	--for i = 1, self.CURSOR_REDRAW_COUNT do
		local pix = CreateMOPixel("Cursor");
		pix.Pos = self.Mouse + Vector(6 , 6);
		MovableMan:AddParticle(pix);
	--end
end
-----------------------------------------------------------------------------------------
-- Draw label element
-----------------------------------------------------------------------------------------
function Warfare2:DrawLabel(el , state)
	-- Labels can ommit presets or texts
	if el["Preset"] then
		local pix = CreateMOPixel(el["Preset"]);
		pix.Pos = el.Pos;
		MovableMan:AddParticle(pix);
	end
	
	if el["Text"] then
		local centered = true;
		
		if el["Centered"] ~= nil and el["Centered"] == false then
			centered = false
		end
		
		if centered then
			local w = CF_GetStringPixelWidth(el["Text"]);
			CF_DrawString(el["Text"], Vector(el.Pos.X - (w / 2) + 4, el.Pos.Y), el["Width"], el["Height"])
		else
			CF_DrawString(el["Text"], el.Pos, el["Width"], el["Height"])
		end
	end
end
-----------------------------------------------------------------------------------------
-- Draw button element
-----------------------------------------------------------------------------------------
function Warfare2:DrawButton(el , state)
	--for i = 1, self.BUTTON_REDRAW_COUNT do
		local isvisible = true;
		
		if el["Visible"] ~= nil then
			if el["Visible"] == false then
				isvisible = false;
			end
		end
	
		if isvisible then
			local pix = CreateMOPixel(el["Presets"][state]);
			pix.Pos = el.Pos;
			MovableMan:AddParticle(pix);
			
			if el["Text"] then
				local w = CF_GetStringPixelWidth(el["Text"]);
				CF_DrawString(el["Text"], Vector(el.Pos.X - (w / 2) + 4, el.Pos.Y), el["Width"], el["Height"])
			end
		end
	--end
end
-----------------------------------------------------------------------------------------
-- Check if pos is within button area
-----------------------------------------------------------------------------------------
function Warfare2:IsWithinButton(el, pos)
	local isvisible = true;
	
	if el["Visible"] ~= nil then
		if el["Visible"] == false then
			isvisible = false;
		end
	end

	if isvisible then
		local elpos = el["Pos"]
		local wx = el["Width"]
		local wy = el["Height"]
		
		if pos.X > elpos.X - (wx / 2) and pos.X < elpos.X + (wx / 2) and pos.Y > elpos.Y - (wy / 2) and pos.Y < elpos.Y + (wy / 2) then
			return true;
		end
	end

	return false;
end
-----------------------------------------------------------------------------------------
-- Redraw non-custom elements
-----------------------------------------------------------------------------------------
function Warfare2:RedrawKnownFormElements()
	for i = 1 , #self.UI do
		-- Redraw button
		if self.UI[i]["Type"] == self.ElementTypes.BUTTON then
			local state = self.ButtonStates.IDLE;
			
			if i == self.MouseOverElement then
				state = self.ButtonStates.MOUSE_OVER;
			end

			if i == self.MousePressedElement then
				state = self.ButtonStates.PRESSED;
			end
			
			self:DrawButton(self.UI[i], state)
		end

		if self.UI[i]["Type"] == self.ElementTypes.LABEL then
			self:DrawLabel(self.UI[i], nil)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Get element id above whicj mouse currently is
-----------------------------------------------------------------------------------------
function Warfare2:GetMouseOverKnownFormElements()
	for i = 1 , #self.UI do
		if self.UI[i]["Type"] == self.ElementTypes.BUTTON then
			if self:IsWithinButton(self.UI[i], self.Mouse) then
				return i
			end
		end
	end
	
	return nil;
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Warfare2:UpdateActivity()
	-- Just check for intialization flags in update loop to avoid unnecessary function calls during all the mission
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end
	
	if not self.IsInitialized then
		--Init mission if we're still not
		self:StartActivity()
	end
	
	if self.ActivityState == Activity.OVER then
		return
	end

	if self.ProcessBeforeAnything ~= nil then
		self:ProcessBeforeAnything()
	end
	
	--Read standard input, ugly but at least it will be operational if mouse fail for
	-- whatever reason
	local cont = self.brain:GetController();

	if CF_EnableKeyboardControls then
		if cont:IsState(Controller.MOVE_LEFT) then
			self.Mouse = self.Mouse + Vector(-5,0)
		end

		if cont:IsState(Controller.MOVE_RIGHT) then
			self.Mouse = self.Mouse + Vector(5,0)
		end

		if cont:IsState(Controller.MOVE_UP) then
			self.Mouse = self.Mouse + Vector(0,-5)
		end

		if cont:IsState(Controller.MOVE_DOWN) then
			self.Mouse = self.Mouse + Vector(0,5)
		end
	else
		-- Read mouse input
		self.Mouse = self.Mouse + UInputMan:GetMouseMovement(0);
	end
	
	-- Find out info about UInputMan buttons
	--for i = 1, 128 do
	--	if UInputMan:KeyPressed(i) then
	--		print (i)
	--	end
	--end

	-- Don't let the cursor leave the screen
	if self.Mouse.X - self.Mid.X < -self.ResX2 then
		self.Mouse.X = self.Mid.X - self.ResX2;
	end
	
	if self.Mouse.Y - self.Mid.Y < -self.ResY2 then
		self.Mouse.Y = self.Mid.Y - self.ResY2;
	end

	if self.Mouse.X - self.Mid.X > self.ResX2 - 10 then
		self.Mouse.X = self.Mid.X + self.ResX2 - 10;
	end
	
	if self.Mouse.Y - self.Mid.Y > self.ResY2 - 10 then
		self.Mouse.Y = self.Mid.Y + self.ResY2 - 10;
	end

	self:DrawMouseCursor();

	if self.FormValid then
		-- Process mouse hovers and presses
		if CF_EnableKeyboardControls then
			-- Process standard input
			if cont:IsState(Controller.WEAPON_FIRE) then
				self.MousePressedElement = self:GetMouseOverKnownFormElements()

				if self.MousePressedElement ~= nil then
					if self.UI[self.MousePressedElement]["OnClick"] ~= nil then
						self.UI[self.MousePressedElement]["OnClick"](self)
						
						if self.ExitImmediately then
							return
						end
					end
				end

				self:FormClick()
				
				self.MouseOverElement = nil;
				self.MousePressedElement = nil;
				self.MousePressStartElement = nil;
				self.MousePressEndElement = nil;
			end
		else
			-- Process mouse input
			self.MouseOverElement = self:GetMouseOverKnownFormElements();
			
			if self.MouseOverElement then
				if self.UI[self.MouseOverElement]["OnHover"] ~= nil then
					self.UI[self.MouseOverElement]["OnHover"](self)
				end
			end
			
			if UInputMan:MouseButtonPressed(0) then
				self.MousePressStartElement = self:GetMouseOverKnownFormElements();
				self.MousePressEndElement = nil;
				self.MousePressedElement = self:GetMouseOverKnownFormElements()
			end

			if UInputMan:MouseButtonHeld(0) then
				self.MouseOverElement = nil;
				self.MouseButtonHeld = true
			else
				self.MouseButtonHeld = false
			end
		
			if UInputMan:MouseButtonReleased(0) then
				-- Get element above which mouse was released
				self.MousePressEndElement = self:GetMouseOverKnownFormElements()

				local dontpass = false;
				
				if self.MousePressStartElement ~= nil and self.MousePressStartElement == self.MousePressEndElement then
					if self.MousePressedElement ~= nil then
						if self.UI[self.MousePressedElement]["OnClick"] ~= nil then
							dontpass = true
							self.UI[self.MousePressedElement]["OnClick"](self)
							
							if self.ExitImmediately then
								return
							end
						end
					end
				end
				
				-- Don't pass events which were already handled by known controls
				if not dontpass then
					self:FormClick()
				end
				
				self.MouseOverElement = nil;
				self.MousePressedElement = nil;
				self.MousePressStartElement = nil;
				self.MousePressEndElement = nil;
			end
		end
	end
		
	if self.FormValid then
		self:RedrawKnownFormElements();
		self:FormUpdate()
		self:FormDraw()
	end
	
	--print (self.Mouse - self.Mid)--]]--
end
-----------------------------------------------------------------------------------------
-- Thats all folks!!!
-----------------------------------------------------------------------------------------