-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Warfare2:StartActivity()
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end

	if self.IsInitialized then 
		return
	end

	--self.IsInitialized = true
	
	-- If you are a developer you can turn on/off almost all of
	-- this mission's debug yada-yada with this flag
	self.Debug = false; --true;
	self.DrawWaypoints = false; --true;

	self.SpawnCount = 0
	
   	print("START! -- WarfareGameplay:StartActivity()!");

	self.ModuleName = "Warfare2.rte";
	--config = CF_ReadConfigFile(self.ModuleName , "Factions.dat")

	--CF_PlayerFaction = config["PlayerFaction"]
	--CF_CPUFaction = config["CPUFaction"]
	
	CF_PlayerFaction = PLAYER_FACTION
	CF_CPUFaction = CPU_FACTION
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.PositiveIndex = 1.5;
		self.NegativeIndex = 0.5;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.PositiveIndex = 1.25;
		self.NegativeIndex = 0.75;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.PositiveIndex = 1.0;
		self.NegativeIndex = 1.0;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.PositiveIndex = 0.85;
		self.NegativeIndex = 1.15;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.PositiveIndex = 0.70;
		self.NegativeIndex = 1.3;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.PositiveIndex = 0.55;
		self.NegativeIndex = 1.45;
	end

	self.FundsPerBrain = 1500 * self.NegativeIndex
	self.InitialFunds = 8000 * self.PositiveIndex + self.FundsPerBrain -- Gameplay
	self.DropShipBudget = 650 * self.NegativeIndex
	
	self.CurrentBudget = 0

	-- Adjust funds for multiplayer mode due to extremely difficult gamepad controls
	if self.PlayerCount == 2 then
		self.FundsPerBrain = 1250 * self.NegativeIndex
		self.InitialFunds = 10000 * self.PositiveIndex + self.FundsPerBrain
	elseif self.PlayerCount == 3 then
		self.FundsPerBrain = 1000 * self.NegativeIndex
		self.InitialFunds = 12500 * self.PositiveIndex + self.FundsPerBrain
	elseif self.PlayerCount == 4 then
		self.FundsPerBrain = 750 * self.NegativeIndex
		self.InitialFunds = 15000 * self.PositiveIndex + self.FundsPerBrain
	end

	-- self.InitialFunds = self.FundsPerBrain + 500 -- Debug
	self.FundsPerObjective = (self.FundsPerBrain * 3) * self.PositiveIndex
	
    self.GenericTimer = Timer();

	self.ShowLastObjectiveMessage = false;
	
    self.LastBrainDeath = Timer();
	self.LastBrainDeath:Reset()

    self.LastMoney = Timer();
	self.LastMoney:Reset()
	self.MoneyPerTick = 2 * self.PositiveIndex;

	
	-- This timer starts working when objective starts and is never reset until it ends
	self.ObjectiveTimer = Timer();
	self.ObjectiveTimer:Reset();

	-- After this time objective is autofailed
	if self.PlayerCount > 1 then
		self.ObjectiveTimeout = 300000;
	else
		self.ObjectiveTimeout = 240000;
	end
	
	-- This timer is used by generic respawn mechanism
	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();
	
	self.DefaultSpawnInterval = 15000 * self.PositiveIndex;
	
	-- Init player brain drop zones
	self.BrainDropZones = {}
	local zone = 1
	local enough = false

	while not enough do
		if SceneMan.Scene:HasArea("BrainDropZone"..zone) then
			self.BrainDropZones[zone] = SceneMan.Scene:GetArea("BrainDropZone"..zone)
			zone = zone + 1
		else
			enough = true
		end
	end
	
	print ("Brain zones = "..zone)
	
	self.EnemyDropZone = nil;
	if SceneMan.Scene:HasArea("EnemyDropZone") then
		self.EnemyDropZone = SceneMan.Scene:GetArea("EnemyDropZone")
	end
	
	self.ObjectiveComplete = true;
	self.CompletedObjectivesCount = 0;
	-- Objectives neede to win
	self.CompletedObjectivesToWin = 10;
	
	-- Pause between objectives
	self.LastObjectivePause = 25000;
	-- Time to show objective text
	self.ObjectiveTextShowTime = 7500;
	
	-- Init objective types
	self.ObjectiveAvailable = {};
	self.ObjectiveCheck = {};
	self.ObjectiveInit = {};
	self.ObjectiveUpdate = {};
	self.ObjectiveEnabled = {};

	
	-- Debug: Execute objectives functions to check for errors
	--self:ClearAvailable()
	--self:ClearCheck()
	--self:ClearInit()
	--self:ClearUpdate()
	
	-- Objectives consists of three functions.
	-- Available - chieks if this objective can be launched on selected scene
	-- Check - checks if this objective can be launched and all prerequisities are met. Returns true if so or false otherwise.
	-- Init - initializes all objective variables before the execution
	-- Update - updates the objective. Once objective is complete it sets self.ObjectiveComplete to true
	-- and objective manager starts new objective.

	-- Clear objective
	self.ObjectiveAvailable[1] = self.ClearAvailable;
	self.ObjectiveCheck[1] = self.ClearCheck;
	self.ObjectiveInit[1] = self.ClearInit;
	self.ObjectiveUpdate[1] = self.ClearUpdate;

	-- Hold objective
	self.ObjectiveAvailable[2] = self.HoldAvailable;
	self.ObjectiveCheck[2] = self.HoldCheck;
	self.ObjectiveInit[2] = self.HoldInit;
	self.ObjectiveUpdate[2] = self.HoldUpdate;

	-- Orbital objective
	self.ObjectiveAvailable[3] = self.OrbitalAvailable;
	self.ObjectiveCheck[3] = self.OrbitalCheck;
	self.ObjectiveInit[3] = self.OrbitalInit;
	self.ObjectiveUpdate[3] = self.OrbitalUpdate;

	-- Flak objective
	self.ObjectiveAvailable[4] = self.FlakAvailable;
	self.ObjectiveCheck[4] = self.FlakCheck;
	self.ObjectiveInit[4] = self.FlakInit;
	self.ObjectiveUpdate[4] = self.FlakUpdate;

	-- Last man objective
	self.ObjectiveAvailable[5] = self.LastManAvailable;
	self.ObjectiveCheck[5] = self.LastManCheck;
	self.ObjectiveInit[5] = self.LastManInit;
	self.ObjectiveUpdate[5] = self.LastManUpdate;

	-- Intel objective
	self.ObjectiveAvailable[6] = self.IntelAvailable;
	self.ObjectiveCheck[6] = self.IntelCheck;
	self.ObjectiveInit[6] = self.IntelInit;
	self.ObjectiveUpdate[6] = self.IntelUpdate;

	-- Boss objective
	self.ObjectiveAvailable[7] = self.BossAvailable;
	self.ObjectiveCheck[7] = self.BossCheck;
	self.ObjectiveInit[7] = self.BossInit;
	self.ObjectiveUpdate[7] = self.BossUpdate;

	-- Beacon objective
	self.ObjectiveAvailable[8] = self.BeaconAvailable;
	self.ObjectiveCheck[8] = self.BeaconCheck;
	self.ObjectiveInit[8] = self.BeaconInit;
	self.ObjectiveUpdate[8] = self.BeaconUpdate;

	-- DogTag objective
	self.ObjectiveAvailable[9] = self.DogTagAvailable;
	self.ObjectiveCheck[9] = self.DogTagCheck;
	self.ObjectiveInit[9] = self.DogTagInit;
	self.ObjectiveUpdate[9] = self.DogTagUpdate;

	-- Bombing objective
	self.ObjectiveAvailable[10] = self.BombingAvailable;
	self.ObjectiveCheck[10] = self.BombingCheck;
	self.ObjectiveInit[10] = self.BombingInit;
	self.ObjectiveUpdate[10] = self.BombingUpdate;--]]--

	--Single place to turn on/off objectives
	self.ObjectiveEnabled[1] = true; -- Clear
	self.ObjectiveEnabled[2] = true; -- Hold
	self.ObjectiveEnabled[3] = true; -- Orbital strike
	self.ObjectiveEnabled[4] = true; -- Flak defence
	self.ObjectiveEnabled[5] = true; -- Last man standing
	self.ObjectiveEnabled[6] = true; -- Intelligence
	self.ObjectiveEnabled[7] = true; -- Boss
	self.ObjectiveEnabled[8] = true; -- Beacon
	self.ObjectiveEnabled[9] = true; -- Dog Tags
	self.ObjectiveEnabled[10] = true; -- Bombing
	
	-- Select objectives available on this scene
	self.AvailableObjectives = {}
	
	for i,func in ipairs(self.ObjectiveAvailable) do
		if self.ObjectiveEnabled[i] then
			-- print (i)
			if func ~= nil and func(self) then
				self.AvailableObjectives[#self.AvailableObjectives + 1] = i;
			end
		end
	end
	
	-- DEBUG!!! Test just a single objective
	--self.AvailableObjectives = {}
	--self.AvailableObjectives[1] = 1
	
	-- Debug
	--for i = 1, #self.AvailableObjectives do
	--	print(self.AvailableObjectives[i])
	--end
	
	self.ActiveObjective = nil
	self.LastObjective = nil
	
   	-- Set up teams
   	-- Team 2 is always CPU
	self.PlayerTeam = Activity.TEAM_1;
   	self.CPUTeam = Activity.TEAM_2;
	self.RogueTeam = -1;

	CF_ReplaceActors(MovableMan.AddedActors)
	CF_ReplaceActors(MovableMan.Actors)
	
    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    -- Set the team's funds.
    self:SetTeamFunds(self.InitialFunds , self.PlayerTeam);

    -- Reset all timers
	self.GenericTimer:Reset();
	
	-- Spawn initial brains
	for player = 0, self.PlayerCount - 1 do
		local team = self:GetTeamOfPlayer(player);
		local newBrain = self:RespawnPlayerBrain();
		
		if newBrain then
			self:SetPlayerBrain(newBrain, player);
			self:SwitchToActor(newBrain, player, team);
		end
	end
	
	self.IsInitialized = true
	
	--print ("Initialized")
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function Warfare2:PauseActivity(pause)
    print("PAUSE! -- DummyAssault:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function Warfare2:EndActivity()
    print("END! -- DummyAssault:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Warfare2:SelectNewObjective()
	-- Finalize previous objective completion
	if self.ObjectiveComplete then
		print ("Objective complete")
		self.ObjectiveComplete = false;
		self.GenericTimer:Reset()
		self.ActiveObjective = nil;
		self.ShowLastObjectiveMessage = true;
	end
	
	if self.ActiveObjective == nil then
		if self.GenericTimer:IsPastSimMS(self.LastObjectivePause) then
			print ("Start new objective selection")
			local selected = 0;
			-- Make 5 attempts to select new random objective
			for i = 1, 5 do
				local r = math.random(#self.AvailableObjectives);
				
				-- Don't let the script select one objective again and again
				if self.AvailableObjectives[r] ~= self.LastObjective then
					if self.ObjectiveCheck[self.AvailableObjectives[r]](self) then
						selected = self.AvailableObjectives[r];
						break
					end
				end
			end
			
			-- Try to select any available objective
			if selected == 0 then
				for i = 1, #self.AvailableObjectives do
					-- Don't let the script select one objective again and again
					if self.AvailableObjectives[i] ~= self.LastObjective then
						if self.ObjectiveCheck[self.AvailableObjectives[i]](self) then
							selected = self.AvailableObjectives[i];
							break
						end
					end
				end
			end
			
			-- Finally delay next objective or start new objective
			if selected == 0 then
				print ("Objective not found")
				self.GenericTimer:Reset();
				-- Don't show objective message all the time
				self.ShowLastObjectiveMessage = false
			else
				self.ObjectiveTimer:Reset();
				self.SpawnTimer:Reset();
				self.ObjectiveInit[selected](self)
				self.LastObjective = selected;
				self.ActiveObjective = selected;
				self.ObjectiveCompleteText = nil
			end
		else
			-- Disable any objective execution to show completion text
			self.ActiveObjective = nil;
			
			if (self.CompletedObjectivesCount > 0) then
				local text = "OBJECTIVE "..self.CompletedObjectivesCount.." ENDED"
				if self.ObjectiveCompleteText then
					text = self.ObjectiveCompleteText
				end

				if self.ShowLastObjectiveMessage then
					if not self.GenericTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
						for player = 0 , self.PlayerCount - 1 do
							FrameMan:SetScreenText(text, player, 0, 1, true);
						end
					else
						for player = 0 , self.PlayerCount - 1 do
							FrameMan:SetScreenText("NO OBJECTIVE", player, 0, 1, false);
						end
					end
				else
					for player = 0 , self.PlayerCount - 1 do
						FrameMan:SetScreenText("NO OBJECTIVE", player, 0, 1, false);
					end
				end
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Warfare2:RemoveInventoryItem(actor , itempreset)
	local count = 0;
	local toabort = 0
	
	if MovableMan:IsActor(actor) and actor.ClassName == "AHuman" then
		if actor:HasObject(itempreset) then
			local human = ToAHuman(actor);
		
			if human.EquippedItem ~= nil then
				if human.EquippedItem.PresetName == itempreset then
					human.EquippedItem.ToDelete = true;
					count = 1;
				end
			end

			if not actor:IsInventoryEmpty() then
				actor:AddInventoryItem(CreateTDExplosive("WarfareInventoryMarker" , self.ModuleName));
				
				local enough = false;
				while not enough do
					local weap = actor:Inventory();
					
					if weap.PresetName == itempreset then
						weap = actor:SwapNextInventory(nil, true);
						count = count + 1;
					else
						if weap.PresetName == "WarfareInventoryMarker" then
							enough = true;
							actor:SwapNextInventory(nil, true);
						else
							weap = actor:SwapNextInventory(weap, true);
						end
					end
					
					toabort = toabort + 1
					if toabort == 20 then
						enough = true;
					end
				end
			end
		end
	end
	
	-- print (tostring(count).." items removed")
	return count;
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Warfare2:SelectSafeLZ(friendlyteam, enemyteam, areas, radius)
	local enemies = {}
	local friends = {}

	local safe = 1
	
	for i = 1, #areas do
		local lz = areas[i]:GetCenterPoint()
		
		enemies[i] = 0
		friends[i] = 0
		
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance(actor.Pos, lz, true).Magnitude;
			
			if dist <= radius then
				if actor.Team == friendlyteam then
					friends[i] = friends[i] + 1
				end
					
				if actor.Team == enemyteam then
					enemies[i] = enemies[i] + 1
				end
			end
		end
		
		-- Now check if zone is safest
		if enemies[i] < enemies[safe] then
			safe = i;
		elseif enemies[i] == enemies[safe] then
			if math.random() < 0.3 then
				safe = i;
			end
		end
	end
	
	return areas[safe]
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:SpawnRandomInfantry(team , pos , faction , aimode)
	local actor = nil;
	local r1, r2;
	local item;
	
	local price = 0
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		-- Find AHuman
		local ok = false;
		-- Emergency counter in case we don't have AHumans in factions
		local counter = 0
		
		while (not ok) do
			ok = false;
			r1 = math.random(#CF_ActNames[faction])

			if CF_ActTypes[faction][r1] ~= CF_ActorTypes.TURRET and CF_ActTypes[faction][r1] ~= CF_ActorTypes.ARMOR and CF_ActPowers[faction][r1] > 0 and CF_ActClasses[faction][r1] ~= "ACrab" then
				ok = true;
			end
			
			-- Break to avoid endless loop
			counter = counter + 1
			if counter > 80 then
				break
			end
		end
		
		local class = CF_ActClasses[faction][r1]
		local preset = CF_ActPresets[faction][r1]
		
		if class == nil then
			class = "AHuman"
		end
		
		price = price + CF_ActPrices[faction][r1]

		if class == "AHuman" then
			local giveweapons = true

			if CF_PreEquippedActors[faction] ~= nil then
				if CF_PreEquippedActors[faction] == true then
					giveweapons = false
				end
			end
			
			-- Don't give any weapons to any actors with pre-equipped items
			if CF_DiscardableItems ~= nil then
				if CF_DiscardableItems[preset] ~= nil then
					giveweapons = false
				end
			end
		
			if giveweapons then
				-- Find suitable weapon
				local ok = false;
				-- Emergency counter in case we don't have AHumans in factions
				local counter = 0
				
				while (not ok) do
					ok = false;
					r2 = math.random(#CF_ItmNames[faction])
			
					if (CF_ItmTypes[faction][r2] == CF_WeaponTypes.RIFLE or CF_ItmTypes[faction][r2] == CF_WeaponTypes.SHOTGUN or 
						CF_ItmTypes[faction][r2] == CF_WeaponTypes.SNIPER or CF_ItmTypes[faction][r2] == CF_WeaponTypes.HEAVY) and CF_ItmPowers[faction][r2] > 0 then
						ok = true;
					end
					
					-- Break to avoid endless loop
					counter = counter + 1
					if counter > 40 then
						break
					end
				end
				
				price = price + CF_ItmPrices[faction][r2]
			end
		end
		
		local ok2spawn = true
		
		if self.CurrentBudget - price < 0 then
			ok2spawn = false
		end
		
		if ok2spawn then
			actor = CF_MakeActor(CF_ActPresets[faction][r1] , CF_ActClasses[faction][r1], CF_ActModules[faction][r1]);
			
			if actor ~= nil then
				self.CurrentBudget = self.CurrentBudget - price
				--print (CF_ActPresets[faction][r1] .." - " ..CF_ActPrices[faction][r1])
				--print (CF_ItmPresets[faction][r2] .." - " ..CF_ItmPrices[faction][r2])
				
				--print ("---------" .. price)

				if class == "AHuman" then
					if r2 ~= nil then
						item = CF_MakeItem(CF_ItmPresets[faction][r2] , CF_ItmClasses[faction][r2], CF_ItmModules[faction][r2]);
						
						if item ~= nil then
							actor:AddInventoryItem(item);
						end
					end
				end
				
				actor.AIMode = aimode;
				actor.Team = team;
				
				if pos ~= nil then
					actor.Pos = pos;
				end
				return actor
			end
		end
	end
	
	return nil
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Warfare2:SpawnRandomArmor(team , pos , faction , aimode)
	local actor = nil;
	local r1, r2;
	local item;
	
	local price = 0
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		-- Find AHuman
		local ok = false;
		-- Emergency counter in case we don't have AHumans in factions
		local counter = 0
		
		while (not ok) do
			ok = false;
			r1 = math.random(#CF_ActNames[faction])

			if CF_ActTypes[faction][r1] == CF_ActorTypes.ARMOR and CF_ActPowers[faction][r1] > 0 then
				ok = true;
			end
			
			-- Break to avoid endless loop
			counter = counter + 1
			if counter > 80 then
				break
			end
		end
		
		local class = CF_ActClasses[faction][r1]
		local preset = CF_ActPresets[faction][r1]
		
		if class == nil then
			class = "AHuman"
		end
		
		if class == "AHuman" then
			local giveweapons = true

			if CF_PreEquippedActors[faction] ~= nil then
				if CF_PreEquippedActors[faction] == true then
					giveweapons = false
				end
			end
			
			-- Don't give any weapons to any actors with pre-equipped items
			if CF_DiscardableItems ~= nil then
				if CF_DiscardableItems[preset] ~= nil then
					giveweapons = false
				end
			end
		
			if giveweapons then
				-- Find suitable weapon
				local ok = false;
				-- Emergency counter in case we don't have AHumans in factions
				local counter = 0
				
				while (not ok) do
					ok = false;
					r2 = math.random(#CF_ItmNames[faction])
			
					if (CF_ItmTypes[faction][r2] == CF_WeaponTypes.RIFLE or CF_ItmTypes[faction][r2] == CF_WeaponTypes.SHOTGUN or 
						CF_ItmTypes[faction][r2] == CF_WeaponTypes.SNIPER or CF_ItmTypes[faction][r2] == CF_WeaponTypes.HEAVY) and CF_ItmPowers[faction][r2] > 0 then
						ok = true;
					end
					
					-- Break to avoid endless loop
					counter = counter + 1
					if counter > 40 then
						break
					end
				end
			end
		end
		
		actor = CF_MakeActor(CF_ActPresets[faction][r1] , CF_ActClasses[faction][r1], CF_ActModules[faction][r1]);
		
		if actor ~= nil then
			self.CurrentBudget = self.CurrentBudget - price

			if class == "AHuman" then
				if r2 ~= nil then
					item = CF_MakeItem(CF_ItmPresets[faction][r2] , CF_ItmClasses[faction][r2], CF_ItmModules[faction][r2]);
					
					if item ~= nil then
						actor:AddInventoryItem(item);
					end
				end
			end
			
			actor.AIMode = aimode;
			actor.Team = team;
			
			if pos ~= nil then
				actor.Pos = pos;
			end
			return actor
		end
	end
	
	return nil
end
-----------------------------------------------------------------------------------------
-- Spawns random enemy dropship at specified intervals and on selected dropzone. 
-- If dropzone is null spawns at random position
-----------------------------------------------------------------------------------------
function Warfare2:SpawnRandomEnemyDropship(interval, dropzone, aimode, brainchase)
	-- Don't even try to spawn a dropship if we're limited by MOIDs, it will spawn empty anyway
	if self.SpawnTimer:IsPastSimMS(interval) and MovableMan:GetMOIDCount() <= CF_MOIDLimit - 15 then
		--print ("Spawn")
		local pos;
		
		-- Select LZ
		if dropzone then
			--print ("SPAWN: Custom Dropzone")
			pos = Vector(dropzone:GetRandomPoint().X, 0);
		else
			if brainchase then
				--print ("SPAWN: Brain chase")
				pos = nil;
				-- Spawn dropships near player brain if we're chasing it
				for player = 0, self.PlayerCount -1 do
					local brain = self:GetPlayerBrain(player)
					
					if MovableMan:IsActor(brain) then
						if math.random() < 0.5 then
							pos = Vector(brain.Pos.X - 250, 0)
						else
							pos = Vector(brain.Pos.X + 250, 0)
						end
						
						if pos.X < 0 then
							pos = Vector(brain.Pos.X + 250, 0);
						end
					
						if pos.X > SceneMan.Scene.Width then
							pos = Vector(brain.Pos.X - 250, 0);
						end
					end
					
					if pos == nil then
						pos = Vector(100 + math.random(SceneMan.Scene.Width - 200), 0);
					end
				end
			else
				if self.EnemyDropZone then
					--print ("SPAWN: Enemy Dropzone")
					pos = Vector(self.EnemyDropZone:GetRandomPoint().X, 0);
				else
					--print ("SPAWN: Random")
					pos = Vector(100 + math.random(SceneMan.Scene.Width - 200), 0);
				end
			end
		end
		
		self.CurrentBudget = self.DropShipBudget
		
		local ship = CF_MakeDropship(self.CPUTeam, pos, CF_CPUFaction, false)
		--print (ship)
		-- Check if ship was actually created because if we're out of MOIDs 
		-- it will return null and crash the game
		if ship then
			local actor;
			if math.random() > 0.075 then
				local unitcount = 0
			
				for a = 1, 14 do
					actor = self:SpawnRandomInfantry(self.CPUTeam , nil , CF_CPUFaction , aimode, false)
					if actor then
						unitcount = unitcount + 1
						if math.random() < 0.075 then
							actor:AddInventoryItem(CreateHDFirearm("Heavy Digger"));
						end
						
						ship:AddInventoryItem(actor)
						
						-- Check if dropship overloaded
						if ship.MaxMass ~= nil and ship.MaxMass > 0 then
							if ship.Mass >= ship.MaxMass then
								print ("Dropship overloaded, will deliver only "..a.." units")
								break;
							end
						end						
					end
				end
				
				print ("Loaded ".. unitcount .." units. " .. self.DropShipBudget - self.CurrentBudget .. "/" .. self.DropShipBudget .." oz spent.")
			else
				actor = self:SpawnRandomArmor(self.CPUTeam , nil , CF_CPUFaction , aimode)
				
				if actor then
					ship:AddInventoryItem(actor)
					print ("Loaded armor unit")
				else
					-- If there's no armor units, then loads at least something
					actor = self:SpawnRandomInfantry(self.CPUTeam , nil , CF_CPUFaction , aimode, false)
					if actor then
						ship:AddInventoryItem(actor)
					end
				end
			end
			
			MovableMan:AddActor(ship)
			self.SpawnTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Warfare2:RespawnPlayerBrain()
	print ("Warfare2:RespawnPlayerBrain")
	if self:GetTeamFunds(self.PlayerTeam) >= self.FundsPerBrain then
		self.SpawnCount = self.SpawnCount + 1
	
		self.LastBrainDeath:Reset()
		-- Pay for new brain
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) - self.FundsPerBrain, self.PlayerTeam)
		
		local lz = self:SelectSafeLZ(self.PlayerTeam , self.CPUTeam, self.BrainDropZones, 800)
		local x = 0;
		if lz then
			x = lz:GetRandomPoint().X
		else
			print ("Random brain drop zone selected!")
			x = 100 + math.random(SceneMan.Scene.Width - 200);
		end
		
		local alt = SceneMan:FindAltitude(Vector(x, 0), 0, 10) - 100
		if alt < 0 then
			alt = 0
		else
			alt = (math.random(alt) / 4) * (self.SpawnCount % 4)
		end
		
		local pos = Vector(x, alt)
		local ship = CF_MakeDropship(self.PlayerTeam, pos, CF_PlayerFaction, true)
		local brain = CF_MakeBrain(CF_PlayerFaction)
		if brain then
			brain.Team = self.PlayerTeam
			
			local brainweapons = {CF_WeaponTypes.RIFLE,CF_WeaponTypes.RIFLE, CF_WeaponTypes.SHOTGUN, CF_WeaponTypes.SNIPER, CF_WeaponTypes.HEAVY}
			
			for i = 1, 2 do
				-- Give brain some weapons
				local w = CF_GetAnyOfThoseWeapons(CF_PlayerFaction, brainweapons, false);
				
				if w ~= nil then
					local weap = CF_MakeItem(CF_ItmPresets[CF_PlayerFaction][w], CF_ItmClasses[CF_PlayerFaction][w], CF_ItmModules[CF_PlayerFaction][w])
					if weap ~= nil then
						brain:AddInventoryItem(weap)
					end
				end
			end			
			
		end
		
		ship:AddInventoryItem(brain)
		MovableMan:AddActor(ship)
		return ship;
	else
		return nil;
	end
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Warfare2:DoBrainSelection()
	--print ("Warfare2:DoBrainSelection")
	self.BrainWasDeadLastTime = false
	
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
	
			local brain = self:GetPlayerBrain(player);
			--print (brain)
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self.BrainWasDeadLastTime = true
			
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				
				if not newBrain then
					newBrain = self:RespawnPlayerBrain();
				end
				
				if newBrain then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 333, -1, false);
					self.WinnerTeam = self:OtherTeam(team);
					ActivityMan:EndActivity();
				end--]]--
			else
				--if not self.LastBrainDeath:IsPastSimMS(5000) then
					self:AddObjectivePoint("Protect!", brain.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN)
				--end
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Warfare2:UpdateActivity()
	-- Just check for intialization flags in update loop to avoid unnecessary function calls during all the mission
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end

   	-- Clear all objective markers, they get re-added each frame
   	self:ClearObjectivePoints();
	
	if not self.IsInitialized then
		--Init mission if we're still not
		self:StartActivity()
	end	

	
    -- Give player money all the time to avoid money cheating
	if self.LastMoney:IsPastSimMS(500) then
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.MoneyPerTick, self.PlayerTeam)
		self.LastMoney:Reset()
	end
	
	if self.ActiveObjective ~= nil then
		self.ObjectiveUpdate[self.ActiveObjective](self);
	else
		-- When no objectives present just spawn infantry like in skirmish
		if math.random() < 0.05 then
			-- Spawn near brain sometimes
			self:SpawnRandomEnemyDropship(self.DefaultSpawnInterval, nil, Actor.AIMODE_BRAINHUNT, true)	
		else
			self:SpawnRandomEnemyDropship(self.DefaultSpawnInterval, nil, Actor.AIMODE_BRAINHUNT, false)	
		end
	end
	
	if #self.AvailableObjectives > 0 then
		self:SelectNewObjective();
	end
	
   	self:DoBrainSelection();
	self:CheckWinningConditions();
	self:YSortObjectivePoints();--]]--
	
	-- DEBUG!!! Kill enemies to test objectives
	--[[for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			if math.random() < 0.1 then
				actor.Health = actor.Health - math.random() * 0.01
			end
			
			if math.random() < 0.0001 then
				actor.Health = 0;
			end
		end
	end--]]--
end
-----------------------------------------------------------------------------------------
-- Check if we are victorious
-----------------------------------------------------------------------------------------
function Warfare2:CheckWinningConditions()
	if self.CompletedObjectivesCount >= self.CompletedObjectivesToWin then
		if self.ActivityState ~= Activity.OVER then
			self.WinnerTeam = self.PlayerTeam
			ActivityMan:EndActivity();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Craft Entered Orbit
-----------------------------------------------------------------------------------------
function Warfare2:CraftEnteredOrbit()
	-- Set flags so objective's update function could track them and trigger events
	if self.OrbitedCraft.Team == self.PlayerTeam then
		self.LastOrbitedCraftWasPlayer = true
		self.LastOrbitedCraftWasCPU = false
	else
		self.LastOrbitedCraftWasPlayer = false
	end
	
	if self.OrbitedCraft.Team == self.CPUTeam then
		self.LastOrbitedCraftWasPlayer = false
		self.LastOrbitedCraftWasCPU = true
	else
		self.LastOrbitedCraftWasCPU = false
	end
	
	if self.OrbitedCraft:HasObject("Memory Chip") then
		self.LastOrbitedCraftHadData = true;
	end
end
-----------------------------------------------------------------------------------------
--	CLEAR AREA OBJECTIVE
--
--	Check for availability of Clear objectives and initialize it
--
--	To complete Clear objective player must kill all enemies in specified area
--
---------------------------------------------------------------------------------------
function Warfare2:ClearAvailable()
	-- Clear objective constants
	-- Number of enemies in clear area required to trigger Clear objective
	self.ClearThreshold = 5
	-- Time between reinforcement respawn
	self.ClearRespawnInterval = self.DefaultSpawnInterval * 0.8;

	-- Init player brain drop zones
	self.ClearEnemyDropZones = {}
	self.ClearAreas = {}
	local zone = 1
	local enough = false

	-- Search for required areas
	while not enough do
		if SceneMan.Scene:HasArea("ClearArea"..zone) then
			self.ClearAreas[zone] = SceneMan.Scene:GetArea("ClearArea"..zone)
			if SceneMan.Scene:HasArea("ClearEnemyDropZone"..zone) then
				self.ClearEnemyDropZones[zone] = SceneMan.Scene:GetArea("ClearEnemyDropZone"..zone)
			end
			zone = zone + 1
		else
			enough = true
		end
	end

	if #self.ClearAreas > 0 then
		print ("+ CLEAR")
		return true;
	end

	return false;
end
-----------------------------------------------------------------------------------------
--	Check if some clear areas contain enemies to kill
-----------------------------------------------------------------------------------------
function Warfare2:ClearCheck()
	print ("CLEAR: check")

	-- Count enemies in clear areas. If count > threshold then objective is available and true returned
	local count = {}
	for i = 1, #self.ClearAreas do
		count[i] = 0;
	end

	for actor in MovableMan.Actors do
		for i = 1, #self.ClearAreas do
			if actor.Team == self.CPUTeam and self.ClearAreas[i]:IsInside(actor.Pos) then
				count[i] = count[i] + 1;
				if count[i] >= self.ClearThreshold then
					return true;
				end
			end
		end
	end
	return false;
end
-----------------------------------------------------------------------------------------
--	Select suitable area for Clear objective. Area with most enemies selected
-----------------------------------------------------------------------------------------
function Warfare2:ClearInit()
	print ("CLEAR: init")
	
	-- Count enemies in clear areas. If count > threshold then objective is available and true returned
	local count = {}
	for i = 1, #self.ClearAreas do
		count[i] = 0;
	end

	for actor in MovableMan.Actors do
		for i = 1, #self.ClearAreas do
			if actor.Team == self.CPUTeam and self.ClearAreas[i]:IsInside(actor.Pos) then
				count[i] = count[i] + 1;
			end
		end
	end
	
	local maxi = 1
	
	for i = 1, #self.ClearAreas do
		if count[i] > count[maxi] then
			maxi = i;
		end
	end
	
	self.ClearSelectedArea = maxi

	-- Set all troops in selected area to sentry and all others to brain hunt
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and self.ClearAreas[self.ClearSelectedArea]:IsInside(actor.Pos) then
			actor.AIMode = Actor.AIMODE_SENTRY;
		else
			actor.AIMode = Actor.AIMODE_BRAINHUNT;
		end
	end
	
	print ("CLEAR started: area "..tostring(maxi))
end
-----------------------------------------------------------------------------------------
--	Update Clear objective state and check winning conditions
-----------------------------------------------------------------------------------------
function Warfare2:ClearUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("CLEAR AREA", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("CLEAR AREA", player, 0, 1, false);
		end
	end

	-- Send generic reinforcements
	-- Set gold dig ai mode so we could find fresh actors later and send them where we need
	self:SpawnRandomEnemyDropship(self.ClearRespawnInterval, self.ClearEnemyDropZones[self.ClearSelectedArea], Actor.AIMODE_GOLDDIG, false)
	
	--print ("Clear update")
	local complete = true

	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			if actor.AIMode == Actor.AIMODE_GOLDDIG then
				actor:ClearAIWaypoints();
				actor.AIMode = Actor.AIMODE_GOTO;
				actor:AddAISceneWaypoint(self.ClearAreas[self.ClearSelectedArea]:GetRandomPoint())
			end
		
			if self.ClearAreas[self.ClearSelectedArea]:IsInside(actor.Pos) then
				if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor" then
					self:AddObjectivePoint("Kill", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
				end
				complete = false
			end
		end
	end
	
	-- Check objective completion and give rewards
	if complete then
		print ("CLEAR: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.GenericTimer:Reset();
	end
	
	if self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTimeout) then
		failed = true
	end
	
	if failed then
		print ("CLEAR: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
end
-----------------------------------------------------------------------------------------
--	HOLD POSITION OBJECTIVE
--
--	Check for availability of Hold objectives and initialize it
--
--	To complete Hold objective player must hold specified position for some time
--
---------------------------------------------------------------------------------------
function Warfare2:HoldAvailable()
	-- Hold objective constants
	-- Number of enemies in clear area required to trigger Hold objective
	self.HoldThreshold = 3
	-- Time between reinforcement respawn
	self.HoldRespawnInterval = self.DefaultSpawnInterval * 0.8;
	-- Time needed to hold
	self.HoldTime = 60000 * self.NegativeIndex;
	
	-- Init player brain drop zones
	self.HoldEnemyDropZones = {}
	self.HoldAreas = {}
	local zone = 1
	local enough = false

	-- Search for required areas
	while not enough do
		if SceneMan.Scene:HasArea("HoldArea"..zone) then
			self.HoldAreas[zone] = SceneMan.Scene:GetArea("HoldArea"..zone)
			if SceneMan.Scene:HasArea("HoldEnemyDropZone"..zone) then
				self.HoldEnemyDropZones[zone] = SceneMan.Scene:GetArea("HoldEnemyDropZone"..zone)
			end
			zone = zone + 1
		else
			enough = true
		end
	end

	if #self.HoldAreas > 0 then
		print ("+ HOLD")
		return true;
	end

	return false;
end
-----------------------------------------------------------------------------------------
--	Check if some hold areas contain enough player units to start
-----------------------------------------------------------------------------------------
function Warfare2:HoldCheck()
	print ("HOLD: check")

	-- Count friends in hold areas. If count > threshold then objective is available and true returned
	local count = {}
	for i = 1, #self.HoldAreas do
		count[i] = 0;
	end

	for actor in MovableMan.Actors do
		for i = 1, #self.HoldAreas do
			if actor.Team == self.PlayerTeam and self.HoldAreas[i]:IsInside(actor.Pos) then
				if (actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor") and not actor:IsInGroup("Brains") then
					count[i] = count[i] + 1;
					if count[i] >= self.HoldThreshold then
						return true;
					end
				end
			end
		end
	end
	return false;
end
-----------------------------------------------------------------------------------------
--	Select suitable area for Hold objective. Area with least friendlies (but > 3) selected
-----------------------------------------------------------------------------------------
function Warfare2:HoldInit()
	print ("HOLD: init")
	
	-- Count enemies in clear areas. If count > threshold then objective is available and true returned
	local count = {}
	for i = 1, #self.HoldAreas do
		count[i] = 0;
	end

	for actor in MovableMan.Actors do
		for i = 1, #self.HoldAreas do
			if actor.Team == self.PlayerTeam and self.HoldAreas[i]:IsInside(actor.Pos) then
				count[i] = count[i] + 1;
			end
		end
	end
	
	local least = 1
	
	for i = 1, #self.HoldAreas do
		if count[i] > count[least]	and count[least] < self.HoldThreshold then
			least = i;
		end
	
		if count[i] < count[least] and count[i] >= self.HoldThreshold then
			least = i;
		end
	end
	
	self.HoldSelectedArea = least
	
	print ("HOLD started: area "..tostring(least))
end
-----------------------------------------------------------------------------------------
--	Update Clear objective state and check winning conditions
-----------------------------------------------------------------------------------------
function Warfare2:HoldUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("HOLD POSITION FOR "..math.floor(self.HoldTime / 1000).." SECONDS\nAT LEAST ONE DEFENDER MUST SURVIVE", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("HOLD POSITION FOR "..math.floor((self.HoldTime - self.ObjectiveTimer.ElapsedSimTimeMS) / 1000).." SECONDS\nAT LEAST ONE DEFENDER MUST SURVIVE", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Send generic reinforcements
	-- Set gold dig ai mode so we could find fresh actors later and send them where we need
	self:SpawnRandomEnemyDropship(self.HoldRespawnInterval, self.HoldEnemyDropZones[self.HoldSelectedArea], Actor.AIMODE_GOLDDIG, false)
	
	local failed = true

	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			if actor.AIMode == Actor.AIMODE_GOLDDIG then
				actor:ClearAIWaypoints();
				actor.AIMode = Actor.AIMODE_GOTO;
				actor:AddAISceneWaypoint(self.ClearAreas[self.ClearSelectedArea]:GetRandomPoint())
			end
		end
		
		if actor.Team == self.PlayerTeam then
			if self.HoldAreas[self.HoldSelectedArea]:IsInside(actor.Pos) then
				if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor" then
					self:AddObjectivePoint("Defender", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
					failed = false
				end
			end
		end
	end
	
	-- Check objective failre
	if failed then
		print ("HOLD: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
	end
	
	-- Check objective completion and give rewards
	if self.ObjectiveTimer:IsPastSimMS(self.HoldTime) then
		print ("HOLD: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.GenericTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
--	ORBITAL BOMBARDMENT OBJECTIVE
--
--	Check for availability of Bombing objectives and initialize it
--
--	To complete Bombing objective player must survive N shots without looisng his brain
--
---------------------------------------------------------------------------------------
function Warfare2:OrbitalAvailable()
	-- Bombing objective constants
	-- Player to enemy units ratio to trigger bombing
	self.OrbitalRatio = 2
	-- Time between shots
	self.OrbitalCannonInterval = 10000 * self.PositiveIndex;
	-- Time between shots
	self.OrbitalChargeInterval = self.OrbitalCannonInterval * 0.75;
	-- Shots to survive
	self.OrbitalShots = math.floor(6 * self.NegativeIndex);
	-- Enemy reinforcements interval
	self.OrbitalRespawnInterval = self.DefaultSpawnInterval
	
	-- Init player brain drop zones
	self.OrbitalHideAreas = {}
	local zone = 1
	local enough = false

	-- Search for required areas
	while not enough do
		if SceneMan.Scene:HasArea("OrbitalHideArea"..zone) then
			self.OrbitalHideAreas[zone] = SceneMan.Scene:GetArea("OrbitalHideArea"..zone)
			zone = zone + 1
		else
			enough = true
		end
	end

	if #self.OrbitalHideAreas > 0 then
		print ("+ ORBITAL")
		return true;
	end

	return false;
end
-----------------------------------------------------------------------------------------
--	Check if orbital prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:OrbitalCheck()
	print ("ORBITAL: check")

	local enemies = 0
	local friends = 0
	local ok = false
	
	-- Count enemies and friends
	for actor in MovableMan.Actors do
		if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor" then
			if actor.Team == self.PlayerTeam then
				friends = friends + 1
				
				-- Check if player's brain is in hide area
				if actor:IsInGroup("Brains") then
					for i = 1, #self.OrbitalHideAreas do
						if self.OrbitalHideAreas[i]:IsInside(actor.Pos) then
							return true
						end
					end
				end
			end

			if actor.Team == self.CPUTeam then
				enemies = enemies + 1
			end
		end
	end
	
	if enemies > 0 and friends > enemies * self.OrbitalRatio then
		return true;
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Init orbital
-----------------------------------------------------------------------------------------
function Warfare2:OrbitalInit()
	print ("ORBITAL: init")

	self.OrbitalCannonTimer = Timer();
	self.OrbitalCannonTimer:Reset();
	
	self.OrbitalShotsFired = 0
	
	print ("ORBITAL started")
end
-----------------------------------------------------------------------------------------
--	Update orbital bombardment
-----------------------------------------------------------------------------------------
function Warfare2:OrbitalUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("INCOMING ORBITAL STRIKE\nBRAIN MUST SURVIVE", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("SURVIVE ".. self.OrbitalShots - self.OrbitalShotsFired  .. " MORE SHOTS", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Control orbital cannon
	-- Targeting
	if self.OrbitalCannonTimer:IsPastSimMS(self.OrbitalCannonInterval - self.OrbitalChargeInterval) then
		-- Get target
		if self.OrbitalCannonTarget == nil then
			-- Search for actors on surface
			for actor in MovableMan.Actors do
				local tofire = false
			
				if actor.Team == self.PlayerTeam then
					if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor" then
						-- Check if actor is close to surface
						local shotpos = SceneMan:MovePointToGround(Vector(actor.Pos.X, 0) , 20 , 3);
						local d = SceneMan:ShortestDistance(actor.Pos, shotpos, true).Magnitude;
						
						-- Add some random to avoid shooting the same actor
						if d < 30 and math.random() < 0.40 then
							tofire = true;
							--actor:FlashWhite(5000);
						end
					end
				end
				
				if tofire then
					self.OrbitalCannonTarget = actor.Pos.X
					self.OrbitalCannonTargetAlt = SceneMan:MovePointToGround(Vector(self.OrbitalCannonTarget, 0) , 20 , 3).Y;
					self.OrbitalLastParticle = self.OrbitalCannonTimer.ElapsedSimTimeMS
					break;
				end
			end
			
			-- If we didn't find a target then shoot brain
			if self.OrbitalCannonTarget == nil then
				for player = 0, self.PlayerCount - 1 do
					local brain = self:GetPlayerBrain(player)
					
					if MovableMan:IsActor(brain) then
						self.OrbitalCannonTarget = brain.Pos.X
						self.OrbitalCannonTargetAlt = SceneMan:MovePointToGround(Vector(self.OrbitalCannonTarget, 0) , 20 , 3).Y;
						self.OrbitalLastParticle = self.OrbitalCannonTimer.ElapsedSimTimeMS
						break;
					end
				end
			end
			
			-- Finally abort targeting
			if self.OrbitalCannonTarget == nil then
				self.OrbitalCannonTimer:Reset();
			end
		else
		-- Show targeting effects
			if self.OrbitalCannonTimer.ElapsedSimTimeMS - self.OrbitalLastParticle > 35 then
				local p = CreateMOPixel("Laser Particle 1 Safe", "Warfare.rte")
				p.Pos = Vector(self.OrbitalCannonTarget -50 + math.random(100), self.OrbitalCannonTargetAlt);
				p.Vel = Vector(0,-(4 + math.random(5)));
				MovableMan:AddParticle(p)
				self.OrbitalLastParticle = self.OrbitalCannonTimer.ElapsedSimTimeMS
			end
		end
		--self:AddObjectivePoint("DANGER", Vector(self.CannonTarget, self.CannonTargetAlt) , self.PlayerTeam, GameActivity.ARROWDOWN)
	end

	-- Shooting
	if self.OrbitalCannonTimer:IsPastSimMS(self.OrbitalCannonInterval) then
		if self.OrbitalCannonTarget ~= nil then
			local p = CreateMOPixel("Laser Glow", "Warfare.rte")
			p.Pos = Vector(self.OrbitalCannonTarget, 0);
			p.Vel = Vector(0,250);
			MovableMan:AddParticle(p)

			for i = 1, 3 do
				local expl = CreateTDExplosive("Base Particle", "Warfare.rte")
				expl.Pos = Vector(self.OrbitalCannonTarget, 0 - i * 20);
				expl.Vel = Vector(0,250);
				expl.Mass = 5000;
				MovableMan:AddParticle(expl)
			end
			
			self.OrbitalCannonTimer:Reset();
			self.OrbitalCannonTarget = nil
			
			self.OrbitalShotsFired = self.OrbitalShotsFired + 1;
		end
	end

	-- Spawn eneimes
	self:SpawnRandomEnemyDropship(self.OrbitalRespawnInterval, nil, Actor.AIMODE_BRAINHUNT,false)
	
	local failed = false;
	
	-- Check if player lost brain
	for player = 0, self.PlayerCount - 1 do
		local brain = self:GetPlayerBrain(player);
		
		if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
			failed = true
		end
	end
	
	-- Check objective failre
	if failed then
		print ("ORBITAL: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
	
	-- Check objective completion and give rewards
	if self.OrbitalShotsFired == self.OrbitalShots then
		print ("ORBITAL: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.GenericTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
--	FLAK OBJECTIVE
--
--	Check for availability of Flak objectives and initialize it
--
--	To complete Flak objective player must shoot down N enemy dropships in a row
--
---------------------------------------------------------------------------------------
function Warfare2:FlakAvailable()
	-- Flak objective constants
	-- Player actors needed to start flak
	self.FlakPlayerActors = 3
	-- Enemy reinforcements interval
	self.FlakRespawnInterval = self.DefaultSpawnInterval
	-- Delay dropships to let player prepare
	self.FlakDelay = self.FlakRespawnInterval * 3
	-- Time to provide flak defence
	self.FlakTime = self.FlakDelay + self.FlakRespawnInterval * 7;
	
	-- Init player brain drop zones
	self.FlakDropZones = {}
	local zone = 1
	local enough = false

	-- Search for required areas
	while not enough do
		if SceneMan.Scene:HasArea("FlakDropZone"..zone) then
			self.FlakDropZones[zone] = SceneMan.Scene:GetArea("FlakDropZone"..zone)
			zone = zone + 1
		else
			enough = true
		end
	end

	if #self.FlakDropZones > 0 then
		print ("+ FLAK")
		return true;
	end

	return false;
end
-----------------------------------------------------------------------------------------
--	Check if flak prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:FlakCheck()
	print ("FLAK: check")

	local friends = 0
	local ok = false
	
	-- Count friends
	for actor in MovableMan.Actors do
		if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor" then
			if actor.Team == self.PlayerTeam then
				friends = friends + 1
			end
		end
	end
	
	if friends >= self.FlakPlayerActors then
		return true;
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Init flak
-----------------------------------------------------------------------------------------
function Warfare2:FlakInit()
	print ("FLAK: init")

	self.FlakDropShips = 0;
	
	-- Select flak dropzone
	self.FlakSelectedDropZone = math.random(#self.FlakDropZones)
	
	print ("FLAK started")
end
-----------------------------------------------------------------------------------------
--	Update flak
-----------------------------------------------------------------------------------------
function Warfare2:FlakUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("DEPLOY ANTI-AIRCRAFT DEFENCE\nDON'T LET A SINGLE ENEMY DROP SHIP ESCAPE", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("KEEP THE SKIES CLEAR FOR "..math.floor((self.FlakTime - self.ObjectiveTimer.ElapsedSimTimeMS) / 1000).. " SECONDS", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Spawn dropships after delay
	if self.ObjectiveTimer:IsPastSimMS(self.FlakDelay) then
		self:SpawnRandomEnemyDropship(self.FlakRespawnInterval, self.FlakDropZones[self.FlakSelectedDropZone], Actor.AIMODE_BRAINHUNT, false)

		-- Mark dropships
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam and (actor.ClassName == "ACDropShip" or actor.ClassName == "ACRocket") then
				self:AddObjectivePoint("Destroy", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	else
		-- Reset escaped dropships before we actually started objective
		self.LastOrbitedCraftWasCPU = false
		self:AddObjectivePoint("Deploy Air Defence", self.FlakDropZones[self.FlakSelectedDropZone]:GetCenterPoint() , self.PlayerTeam, GameActivity.ARROWDOWN);
	end
	
	-- Check objective failre
	local failed = false;
	if self.LastOrbitedCraftWasCPU then
		failed = true
		self.LastOrbitedCraftWasCPU = false
	else
		self.LastOrbitedCraftWasCPU	= false
	end
	
	if failed then
		print ("FLAK: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
	
	-- Check objective completion and give rewards
	if self.ObjectiveTimer:IsPastSimMS(self.FlakTime) then
		print ("FLAK: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.GenericTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
--	LAST MAN OBJECTIVE
--
--	Check for availability of last man standing objectives and initialize it
--
--	To complete Last Man objective player must survive for some time with just a brain
--
---------------------------------------------------------------------------------------
function Warfare2:LastManAvailable()
	-- Enemy reinforcements interval
	self.LastManRespawnInterval = self.DefaultSpawnInterval * 0.85
	-- Time to provide flak defence
	self.LastManTime = 90000 * self.NegativeIndex;

	print ("+ LASTMAN")
	return true;
end
-----------------------------------------------------------------------------------------
--	Check if flak prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:LastManCheck()
	print ("LASTMAN: check")

	-- Never ever launch two last man objectives in a row
	if self.LastObjective == 5 then
		return false;
	end
	
	-- Never launch last man if brain died recently
	if not self.LastBrainDeath:IsPastSimMS(15000) then
		return false;
	end
	
	local friends = 0
	
	-- Count friends
	for actor in MovableMan.Actors do
		if (actor.ClassName == "AHuman" or actor.ClassName == "ACrab" or actor.ClassName == "Actor") and not actor:IsInGroup("Brains") then
			if actor.Team == self.PlayerTeam then
				friends = friends + 1
			end
		end
	end
	
	if friends == 0 and self:GetTeamFunds(self.PlayerTeam) < self.FundsPerBrain then
		if math.random() < 0.25 then
			return true;
		end
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Init last man
-----------------------------------------------------------------------------------------
function Warfare2:LastManInit()
	print ("LASTMAN: init")

	self.FlakDropShips = 0;
	
	self.PlayerFunds = self:GetTeamFunds(self.PlayerTeam);
	self:SetTeamFunds(0, self.PlayerTeam)
	
	print ("LASTMAN started")
end
-----------------------------------------------------------------------------------------
--	Update last man
-----------------------------------------------------------------------------------------
function Warfare2:LastManUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("STORE UPLINK BROKEN\nDON'T LET YOUR BRAIN DIE", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("SURVIVE FOR "..math.floor((self.LastManTime - self.ObjectiveTimer.ElapsedSimTimeMS) / 1000).. " SECONDS", player, 0, self.ObjectiveTextShowTime, false);
		end
	end
	
	-- Reset player money
	self.PlayerFunds = self.PlayerFunds + self:GetTeamFunds(self.PlayerTeam);
	self:SetTeamFunds(0, self.PlayerTeam)

	-- Spawn dropships after delay
	self:SpawnRandomEnemyDropship(self.FlakRespawnInterval, nil, Actor.AIMODE_BRAINHUNT, true)

	-- Mark objectives
	for actor in MovableMan.Actors do
		if actor.Team == self.PlayerTeam and actor:IsInGroup("Brains") then
			self:AddObjectivePoint("Protect", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end

	local failed = false;
	
	-- Check if player lost brain
	for player = 0, self.PlayerCount - 1 do
		local brain = self:GetPlayerBrain(player);
		
		if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
			failed = true
		end
	end
	
	if failed then
		self:SetTeamFunds(self.PlayerFunds, self.PlayerTeam);
		print ("LASTMAN: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
	
	-- Check objective completion and give rewards
	if self.ObjectiveTimer:IsPastSimMS(self.LastManTime) then
		self:SetTeamFunds(self.PlayerFunds, self.PlayerTeam);
		print ("LASTMAN: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.GenericTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
--	INTELLIGENCE OBJECTIVE
--
--	Check for availability of intel objectives and initialize it
--
--	To complete Intelligence objective player must capture intel chip and launch it into orbit
--
---------------------------------------------------------------------------------------
function Warfare2:IntelAvailable()
	-- Enemy reinforcements interval
	self.IntelRespawnInterval = self.DefaultSpawnInterval
	-- How much more units enemy must have to launch intel mission
	self.IntelUnitRatio = 2

	print ("+ INTEL")
	return true;
end
-----------------------------------------------------------------------------------------
--	Check if intel prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:IntelCheck()
	print ("INTEL: check")
	
	local friends = 0
	local enemies = 0
	
	-- Count friends
	for actor in MovableMan.Actors do
		if actor.ClassName == "AHuman" then
			if actor.Team == self.PlayerTeam then
				friends = friends + 1
			end

			if actor.Team == self.CPUTeam then
				enemies = enemies + 1
			end
		end
	end
	
	if friends * self.IntelUnitRatio <= enemies and enemies > 1 then
		return true;
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Init intel
-----------------------------------------------------------------------------------------
function Warfare2:IntelInit()
	print ("INTEL: init")

	local safestactor = nil
	local safestdist = 0
	local nearestenemy = 1000000
	
	-- Find safest enemy soldier
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and actor.ClassName == "AHuman" then
			-- Fins distance to the nearest enemy
			nearestenemy = 100000
			for actor2 in MovableMan.Actors do
				if actor2.Team == self.PlayerTeam then
					local dist = SceneMan:ShortestDistance(actor.Pos, actor2.Pos, true).Magnitude;
					
					if dist < nearestenemy  then
						neasrestenemy = dist;
					end
				end
			end
			
			if neasrestenemy > safestdist then
				safestdist = nearestenemy
				safeactor = actor;
			end
		end
	end
	
	self.LastOrbitedCraftHadData = false
	
	-- Prepare intel unit
	safeactor.Health = 100;
	local itm = CreateHeldDevice("Memory Chip", "Warfare.rte");
	safeactor:AddInventoryItem(itm);
	
	print ("INTEL started")
end
-----------------------------------------------------------------------------------------
--	Update intel
-----------------------------------------------------------------------------------------
function Warfare2:IntelUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("RETREIVE ENEMY MEMORY CHIP\nAND DELIVER IT INTO ORBIT", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("RETREIVE ENEMY MEMORY CHIP", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Spawn dropships
	self:SpawnRandomEnemyDropship(self.FlakRespawnInterval, nil , Actor.AIMODE_BRAINHUNT, false)

	local failed = true;
	
	-- Mark objectives and detect Memory Chip
	for actor in MovableMan.Actors do
		if actor.Team == self.PlayerTeam and actor:HasObject("Memory Chip") then
			self:AddObjectivePoint("Evacuate", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWUP);
			failed = false
		end

		if actor.Team == self.CPUTeam  and actor:HasObject("Memory Chip") then
			self:AddObjectivePoint("Capture", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
			failed = false
		end
	end
	
	for item in MovableMan.Items do
		if item.PresetName == "Memory Chip" then
			self:AddObjectivePoint("Capture", item.Pos + Vector(0,-25) , self.PlayerTeam, GameActivity.ARROWDOWN);
			failed = false;
		end
	end
	
	-- Check objective completion and give rewards
	if self.LastOrbitedCraftHadData then
		print ("INTEL: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.LastOrbitedCraftHadData = false;
		self.GenericTimer:Reset();
		return;
	end
	
	if failed then
		print ("INTEL: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
end
-----------------------------------------------------------------------------------------
--	BOSS OBJECTIVE
--
--	Check for availability of boss objectives and initialize it
--
--	To complete Boss objective player must killdummy behemoth
--
---------------------------------------------------------------------------------------
function Warfare2:BossAvailable()
	self.BossRespawnInterval = self.DefaultSpawnInterval * 1.5;

	if PresetMan:GetModuleID("DummyBehemoth.rte") ~= -1 then
		print ("+ BOSS")
		return true;
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Check if boss prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:BossCheck()
	print ("BOSS: check")
	
	-- Only one boss per round
	if self.BossWasLaunched then
		return false;
	end
	
	if math.random() < 0.15 and self.CompletedObjectivesCount >= 7 then
		return true;
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Init boss
-----------------------------------------------------------------------------------------
function Warfare2:BossInit()
	print ("BOSS: init")

	self.BossWasLaunched = true;
	
	-- Find safe LZ
	local lz = self:SelectSafeLZ(self.PlayerTeam , self.CPUTeam, self.BrainDropZones, 800)
	local x = 0;
	if lz then
		x = lz:GetRandomPoint().X
	else
		x = 250 + math.random(SceneMan.Scene.Width - 500);
	end
	
	local pos = Vector(x, 0)
	local ship = CF_MakeDropship(self.CPUTeam, pos, CF_CPUFaction, true)
	local boss = CreateAHuman("Behemoth", "DummyBehemoth.rte");
	
	ship:AddInventoryItem(boss)
	MovableMan:AddActor(ship)
	
	print ("BOSS started")
end
-----------------------------------------------------------------------------------------
--	Update boss
-----------------------------------------------------------------------------------------
function Warfare2:BossUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("KILL THE BEHEMOTH", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("KILL THE BEHEMOTH", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Spawn dropships
	self:SpawnRandomEnemyDropship(self.BossRespawnInterval, nil , Actor.AIMODE_BRAINHUNT, false)

	local completed = true;
	
	-- Mark objectives and detect Memory Chip
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			if actor.PresetName == "Behemoth" then
				self:AddObjectivePoint("Kill", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
				completed = false
			end
			
			if actor:HasObject("Behemoth") then
				completed = false;
			end
		end
	end

	-- Check objective completion and give rewards
	if completed then
		print ("BOSS: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.LastOrbitedCraftHadData = false;
		self.GenericTimer:Reset();
		return;
	end
end
-----------------------------------------------------------------------------------------
--	BEACON OBJECTIVE
--
--	Check for availability of beacon objectives and initialize it
--
--	To complete Beacon objective player must put 3 soldiers at 3 specified points simultaneously
--
---------------------------------------------------------------------------------------
function Warfare2:BeaconAvailable()
	-- Spawn interval during beacon mission
	self.BeaconRespawnInterval = self.DefaultSpawnInterval * 1.5;
	-- How many beacon points player must occupy
	self.BeaconPointsToControl = 3
	
	-- Init player brain drop zones
	self.BeaconPut = {}
	local zone = 1
	local enough = false

	-- Search for required areas
	while not enough do
		if SceneMan.Scene:HasArea("BeaconPut"..zone) then
			self.BeaconPut[zone] = SceneMan.Scene:GetArea("BeaconPut"..zone)
			zone = zone + 1
		else
			enough = true
		end
	end

	if #self.BeaconPut >= self.BeaconPointsToControl then
		print ("+ BEACON")
		return true;
	end
	return false;
end
-----------------------------------------------------------------------------------------
--	Check if beacon prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:BeaconCheck()
	print ("BEACON: check")

	return true;
end
-----------------------------------------------------------------------------------------
--	Init boss
-----------------------------------------------------------------------------------------
function Warfare2:BeaconInit()
	print ("BEACON: init")
	
	self.BeaconSelectedZones = {}
	
	-- Select random beacon zones
	for i = 1, self.BeaconPointsToControl do
		local ok = false;
	
		while not ok do
			ok = true;
			
			r = math.random(#self.BeaconPut)
			
			for j = 1, #self.BeaconSelectedZones do
				if r == self.BeaconSelectedZones[j] then
					ok = false;
				end
			end
			
			if ok then
				self.BeaconSelectedZones[i] = r;
			end
		end
		-- print (self.BeaconSelectedZones[i])
	end
	
	print ("BEACON started")
end
-----------------------------------------------------------------------------------------
--	Update beacon
-----------------------------------------------------------------------------------------
function Warfare2:BeaconUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("WE NEED TO TRIANGULATE ENEMY BRAIN LOCATION\nPUT SOLDIERS IN DESIGNATED AREAS", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("PUT SOLDIERS IN DESIGNATED AREAS", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Spawn dropships
	self:SpawnRandomEnemyDropship(self.BeaconRespawnInterval, nil , Actor.AIMODE_BRAINHUNT, false)

	local completed = true;
	local failed = false;
	
	-- Mark objectives and detect Memory Chip
	for i = 1, self.BeaconPointsToControl do
		local occupied = false;
		for actor in MovableMan.Actors do
			if actor.Team == self.PlayerTeam then
				if self.BeaconPut[ self.BeaconSelectedZones[i] ]:IsInside(actor.Pos) then
					self:AddObjectivePoint("OK", actor.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
					occupied = true;
					break;
				end
			end
		end

		if not occupied then
			self:AddObjectivePoint("HERE", self.BeaconPut[ self.BeaconSelectedZones[i] ]:GetCenterPoint() , self.PlayerTeam, GameActivity.ARROWDOWN);
			completed = false;
		end
	end

	-- Check objective completion and give rewards
	if completed then
		print ("BEACON: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.LastOrbitedCraftHadData = false;
		self.GenericTimer:Reset();
		return;
	end
	
	-- Fail objective after some time
	if self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTimeout) then
		failed = true
	end
	
	if failed then
		print ("BEACON: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
end
-----------------------------------------------------------------------------------------
--	DOG TAGS OBJECTIVE
--
--	Check for availability of dog tag objectives and initialize it
--
--	To complete dog tag objective player must collect dogtags from enemies
--
---------------------------------------------------------------------------------------
function Warfare2:DogTagAvailable()
	-- Spawn interval during dog tag mission
	self.DogTagRespawnInterval = self.DefaultSpawnInterval * 0.85;
	-- How many dog tags player must collect
	self.DogTagToCollect = math.floor(10 * self.NegativeIndex)

	print ("+ DOGTAG")
	return true;
end
-----------------------------------------------------------------------------------------
--	Check if dog tag prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:DogTagCheck()
	print ("DOGTAG: check")
	return true;
end
-----------------------------------------------------------------------------------------
--	Init dogtag
-----------------------------------------------------------------------------------------
function Warfare2:DogTagInit()
	print ("DOGTAG: init")

	self.DogTagCollected = 0;
	
	for actor in MovableMan.Actors do
		if actor.ClassName == "AHuman" then
			if actor.Team == self.PlayerTeam then
				self:RemoveInventoryItem(actor, "Dog Tag")
			end
		
			if actor.Team == self.CPUTeam then
				local itm = CreateHeldDevice("Dog Tag", "Warfare.rte");
				actor:AddInventoryItem(itm);
			end
		end
	end
	
	print ("DOGTAG started")
end
-----------------------------------------------------------------------------------------
--	Update dogtag
-----------------------------------------------------------------------------------------
function Warfare2:DogTagUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("WE NEED TO BOOST TROOPS MORALE\nCOLLECT ENEMY DOG TAGS", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText(tostring(self.DogTagToCollect - self.DogTagCollected).." DOG TAGS TO COLLECT", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Spawn dropships
	self:SpawnRandomEnemyDropship(self.BeaconRespawnInterval, nil , Actor.AIMODE_BRAINHUNT, false)

	local failed = false;
	
	-- Manage dog tags
	for actor in MovableMan.Actors do
		-- Give dog tags
		if actor.Team == self.CPUTeam then
			if actor.ClassName == "AHuman" then
				if not actor:HasObject("Dog Tag") and actor.Health == 100 then
					local itm = CreateHeldDevice("Dog Tag", "Warfare.rte");
					actor:AddInventoryItem(itm);
				end
			end
		end

		-- Count collected dog tags
		if actor.Team == self.PlayerTeam then
			if actor:HasObject("Dog Tag") then
				self:RemoveInventoryItem(actor, "Dog Tag");
				self.DogTagCollected = self.DogTagCollected + 1
			end
		end
	end
	
	-- Mark dropped dog tags
	for item in MovableMan.Items do
		if item.PresetName == "Dog Tag" then
			self:AddObjectivePoint("Collect", item.Pos + Vector(0, -25) , self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end

	-- Check objective completion and give rewards
	if self.DogTagCollected >= self.DogTagToCollect then
		print ("DOGTAG: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.LastOrbitedCraftHadData = false;
		self.GenericTimer:Reset();
		
		-- Remove all dogtags
		for actor in MovableMan.Actors do
			self:RemoveInventoryItem(actor, "Dog Tag")
		end

		for item in MovableMan.Items do
			if item.PresetName == "Dog Tag" then
				item.ToSettle = true;
			end
		end
		
		return;
	end
	
	-- Fail objective after some time
	if self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTimeout) then
		failed = true
	end
	
	if failed then
		print ("DOGTAG: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();

		-- Remove all dogtags
		for actor in MovableMan.Actors do
			self:RemoveInventoryItem(actor, "Dog Tag")
		end

		for item in MovableMan.Items do
			if item.PresetName == "Dog Tag" then
				item.ToSettle = true;
			end
		end
		
		return;
	end
end
-----------------------------------------------------------------------------------------
--	BOMBING OBJECTIVE
--
--	Check for availability of bombing objectives and initialize it
--
--	To complete bombing objective player must kill enemy marker
--
---------------------------------------------------------------------------------------
function Warfare2:BombingAvailable()
	-- Spawn interval during bombing mission
	self.BombingRespawnInterval = self.DefaultSpawnInterval;
	-- Bombs interval
	self.BombingInterval = 250;
	-- How many actors on open air needed to trigger objective
	self.BombingOpenThreshold = 1;
	-- How many eneies needed to trigger objective
	self.BombingEnemyThreshold = 1;

	-- Init zones
	self.BombingMarkerAreas = {}

	local zone = 1
	local enough = false

	-- Search for required areas
	while not enough do
		if SceneMan.Scene:HasArea("BombingMarkerArea"..zone) then
			self.BombingMarkerAreas[zone] = SceneMan.Scene:GetArea("BombingMarkerArea"..zone)
			zone = zone + 1
		else
			enough = true
		end
	end

	if #self.BombingMarkerAreas > 0 then
		print ("+ BOMBING")
		return true;
	end
	return false;
end
-----------------------------------------------------------------------------------------
--	Check if dog tag prerequisities are met
-----------------------------------------------------------------------------------------
function Warfare2:BombingCheck()
	print ("BOMBING: check")

	local open = 0
	local enemies = 0
	local marker = false;
	
	-- Count friends on open air and enemies
	for actor in MovableMan.Actors do
		if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" then
			if actor.Team == self.PlayerTeam then
				-- Search for troops on surface
				local shotpos = SceneMan:MovePointToGround(Vector(actor.Pos.X, 0) , 20 , 3);
				local d = SceneMan:ShortestDistance(actor.Pos, shotpos, true).Magnitude;
				
				if d < 20 then
					open = open + 1
				end
			end
		end

		if actor.ClassName == "AHuman" then
			if actor.Team == self.CPUTeam then
				enemies = enemies + 1
				
				-- Search for marker
				for i = 1, #self.BombingMarkerAreas do
					if self.BombingMarkerAreas[i]:IsInside(actor.Pos) then
						marker = true;
					end
				end
			end
		end
	end
	
	if enemies >= self.BombingEnemyThreshold and open >= self.BombingOpenThreshold and marker then
		return true;
	end
	
	return false;
end
-----------------------------------------------------------------------------------------
--	Init boss
-----------------------------------------------------------------------------------------
function Warfare2:BombingInit()
	print ("BOMBING: init")

	self.BombingMarker = nil;
	
	self.BombingTimer = Timer();
	self.BombingTimer:Reset();
	
	for actor in MovableMan.Actors do
		if actor.ClassName == "AHuman" then
			if actor.Team == self.CPUTeam then
				-- Search for marker
				for i = 1, #self.BombingMarkerAreas do
					if self.BombingMarkerAreas[i]:IsInside(actor.Pos) then
						self.BombingMarker = actor;
						-- Stop all actors in marker areas to avoid accidental marker killing
						actor.AIMode = Actor.AIMODE_SENTRY;
					end
				end
			end
		end
	end
	
	self.BombingMarker.Health = 100;
	
	print ("BOMBING started")
end
-----------------------------------------------------------------------------------------
--	Update bombing
-----------------------------------------------------------------------------------------
function Warfare2:BombingUpdate()
	-- Print current objective
	if not self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTextShowTime) then
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("INCOMING AIR STRIKE\nKILL ENEMY SPOTTER", player, 0, self.ObjectiveTextShowTime, true);
		end
	else
		for player = 0 , self.PlayerCount - 1 do
			FrameMan:SetScreenText("KILL ENEMY SPOTTER", player, 0, self.ObjectiveTextShowTime, false);
		end
	end

	-- Spawn dropships
	self:SpawnRandomEnemyDropship(self.BombingRespawnInterval, nil , Actor.AIMODE_BRAINHUNT, false)

	-- Mark marker :)
	if MovableMan:IsActor(self.BombingMarker) then
		self:AddObjectivePoint("Kill", self.BombingMarker.AboveHUDPos , self.PlayerTeam, GameActivity.ARROWDOWN);
	else
		self.BombingMarker = nil;
	end
	
	-- Drop bombs
	if self.ObjectiveTimer:IsPastSimMS(self.BombingRespawnInterval * 1.5) then
		if self.BombingTimer:IsPastSimMS(self.BombingInterval) then
			local itm = CreateTDExplosive("Standard Bomb", "Coalition.rte")
			local x;
			
			-- Some of the bombs are random but some are targeted at player actros
			if math.random() < 0.75 then
				x = math.random(SceneMan.Scene.Width)
			else
				for actor in MovableMan.Actors do
					if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" then
						if actor.Team == self.PlayerTeam then
							-- Search for troops on surface
							local shotpos = SceneMan:MovePointToGround(Vector(actor.Pos.X, 0) , 20 , 3);
							local d = SceneMan:ShortestDistance(actor.Pos, shotpos, true).Magnitude;
							
							if d < 30 then
								x = actor.Pos.X + 20 - math.random(40);
								--actor:FlashWhite(500)
								break
							end
						end
					end
				end
			end
			
			-- If we could not select target throw at random
			if not x then
				x = math.random(SceneMan.Scene.Width)
			end
			
			-- Check that we don't hit any CPU actors
			for i = 1, 10 do
				local ok = true;
			
				for actor in MovableMan.Actors do
					if actor.Team == self.CPUTeam then
						-- Search for troops on surface
						local shotpos = SceneMan:MovePointToGround(Vector(x, 0) , 20 , 3);
						local d = SceneMan:ShortestDistance(actor.Pos, shotpos, true).Magnitude;
						
						
						-- Check that landing bomb won't hurt troops
						if d < 120 then
							--actor:FlashWhite(250);
							x = math.random(SceneMan.Scene.Width)
							ok = false;
							break;
						end
					end
					
					-- Check that flying bomb won't hurt dropships
					if actor.ClassName == "ACDropShip" or actor.ClassName == "ACRocket" then
						if math.abs(x - actor.Pos.X) < 120 then
							--actor:FlashWhite(250);
							x = math.random(SceneMan.Scene.Width)
							ok = false;
							break;
						end
					end
				end
				
				if ok then
					break;
				end
			end
			
			itm.Pos = Vector(x, -30)
			itm.Vel = Vector(0, 40);
			itm.RotAngle = math.rad(270)
			
			MovableMan:AddItem(itm);
			self.BombingTimer:Reset();
		end
	end
	
	-- Check objective completion and give rewards
	if self.BombingMarker == nil then
		print ("BOMBING: Complete")
		self.ObjectiveComplete = true
		self.CompletedObjectivesCount = self.CompletedObjectivesCount + 1
		self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.FundsPerObjective, self.PlayerTeam)
		self.ObjectiveCompleteText = "OBJECTIVE COMPLETE [ "..self.CompletedObjectivesCount.." / "..self.CompletedObjectivesToWin.." ]";
		self.LastOrbitedCraftHadData = false;
		self.GenericTimer:Reset();
		return;
	end

	local failed;
	
	-- Fail objective after some time
	if self.ObjectiveTimer:IsPastSimMS(self.ObjectiveTimeout) then
		failed = true
	end
	
	if failed then
		print ("BOMBING: Failed")
		self.ObjectiveComplete = true
		self.ObjectiveCompleteText = "OBJECTIVE FAILED";
		self.GenericTimer:Reset();
		return;
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------
